﻿
local timer
local O,Ot = {},{}
local TESTMODE = false
local version = 1.15
local _,CLASS = UnitClass("player")
------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ LIB
local LSM = LibStub("LibSharedMedia-3.0")
------------------------------------------
local M_statusbar = {}
for i=1,table.getn(LSM:List("statusbar")) do
   M_statusbar[i] = LSM:List("statusbar")[i]
end
local M_font = {}
for i=1,table.getn(LSM:List("font")) do
   M_font[i] = LSM:List("font")[i]
end
local M_border = {}
for i=1,table.getn(LSM:List("border")) do
   M_border[i] = LSM:List("border")[i]
end
local M_background = {}
for i=1,table.getn(LSM:List("background")) do
   M_background[i] = LSM:List("background")[i]
end
------------------------------------------









------------------------------------------
function Sh_OnLoad()
   ------------------------------------------
   
   
   
   -- Frame tooltip
   CreateFrame( "GameTooltip", "MiowTooltip", nil, "GameTooltipTemplate" );
   MiowTooltip:SetOwner( WorldFrame, "ANCHOR_NONE" );
   MiowTooltip:AddFontStrings(
      MiowTooltip:CreateFontString( "$parentTextLeft1", nil, "GameTooltipText" ),
      MiowTooltip:CreateFontString( "$parentTextRight1", nil, "GameTooltipText" ) );
   
   
   -- Slash command
   SLASH_ShieldHealth1 = "/ShieldHealth";
   SLASH_ShieldHealth2 = "/sh";
   SlashCmdList["ShieldHealth"] = function(self)
   InterfaceOptionsFrame_OpenToCategory("Shield Health")
   
		 
		 
   end
   
   
   -- Event
	Sh_EventFrame1 = CreateFrame("Frame", "MyEventFrame1", UIParent)
	Sh_EventFrame1:RegisterEvent("UNIT_AURA")
	Sh_EventFrame1:SetScript("OnEvent", Sh_EventFrame_OnEvent)
	Sh_EventFrame1bis = CreateFrame("Frame", "MyEventFrame1bis", UIParent)
	Sh_EventFrame1bis:RegisterEvent("PLAYER_TARGET_CHANGED")
	Sh_EventFrame1bis:SetScript("OnEvent", Sh_EventFrame_OnEvent)
	
	Sh_EventFrame2 = CreateFrame("Frame", "MyEventFrame2", UIParent)
	Sh_EventFrame2:RegisterEvent("VARIABLES_LOADED")
	Sh_EventFrame2:SetScript("OnEvent", Sh_opt_LOAD)
	Sh_EventFrame3 = CreateFrame("Frame", "MyEventFrame3", UIParent)
	Sh_EventFrame3:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	Sh_EventFrame3:SetScript("OnEvent", Sh_EventFrame3_OnEvent)



	
   -- Timer
   timer = 0
   local timerframe = CreateFrame("frame")
   timerframe:SetScript("OnUpdate", Sh_timer)
   
   
   -- Fonctions
   
   Sh_options()
   Sh_createBar()
   Sh_OnEvent()
 
end


function Sh_options()
   -- Lancé après VARIABLES_LOADED
   ------------------------------------------
   
   ------------------------
   -- Options par défaut --
   ------------------------
		O["version"] = 1.1
		
		O["Ord"] = {1,2,3,4,5,6,7,8,9}
		O["Ord:toggle"] = {true,true,true,true,true,true,true,true,true}
		O["Ord:icon"] = {true,true,true,true,true,true,true,true,true}
		
   
		O["enable"] = true
		O["enable_extase"] = true
		O["short"] = false
		

		O["f:largeur"] = 210 -- Largeur barre du fond
		O["f:hauteur"] = 30 -- Hauteur barre du fond
		O["iconsize"] = 20 -- Taille des icones
		O["level"] = 1
		O["f:pos:1"] = "CENTER"
		O["f:pos:2"] = nil
		O["f:pos:3"] = "CENTER"
		O["f:pos:4"] = 0
		O["f:pos:5"] = -50
		
		O["tex_barre"] = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar" -- Texture des barres des boucliers
		O["f:tex:fond"] = "Interface\\Tooltips\\UI-Tooltip-Background" -- Texture du fond de la barre du fond
		O["f:tex:border"] = "Interface\\Tooltips\\UI-Tooltip-Border" -- Texture de la bordeure de la barre du fond
		O["font:val"] = "Fonts\\FRIZQT__.TTF" -- Text de la valeur des boucliers
		
		O["border:size"] = 4
		O["insets:left"] = 2
		O["insets:right"] = 2
		O["insets:top"] = 2
		O["insets:bottom"] = 2
		
		
		O["font:val:size"] = 18
		O["font:val:r"] = 0.8
		O["font:val:v"] = 1
		O["font:val:b"] = 0.9
		O["font:val:a"] = 1
		O["outline"] = false

		O["f:SBC:r"] = 1 -- Couleur du fond des barres
		O["f:SBC:v"] = 1
		O["f:SBC:b"] = 1
		O["f:SBC:a"] = 0.5

		O["b:a"] = 100

		O["1:r"] = 0 -- Couleur des barres des boucliers
		O["1:v"] = 0
		O["1:b"] = 1
		O["2:r"] = 1
		O["2:v"] = 1
		O["2:b"] = 1
		O["3:r"] = 1
		O["3:v"] = 0
		O["3:b"] = 0
		O["4:r"] = 1
		O["4:v"] = 1
		O["4:b"] = 0
		O["5:r"] = 1
		O["5:v"] = 0.95
		O["5:b"] = 0.77
		O["6:r"] = 0.8
		O["6:v"] = 1
		O["6:b"] = 1
		O["7:r"] = 1
		O["7:v"] = 0.7
		O["7:b"] = 0
		O["8:r"] = 0
		O["8:v"] = 0.7
		O["8:b"] = 0
		O["9:r"] = 0
		O["9:v"] = 0.7
		O["9:b"] = 0


		
		Ot["version"] = 2
		
		Ot["enable"] = true
		Ot["enable_extase"] = true
		Ot["short"] = false

		Ot["f:largeur"] = 210 -- Largeur barre du fond
		Ot["f:hauteur"] = 30 -- Hauteur barre du fond
		Ot["iconsize"] = 20 -- Taille des icones
		Ot["level"] = 1
		Ot["f:pos:1"] = "CENTER"
		Ot["f:pos:2"] = nil
		Ot["f:pos:3"] = "CENTER"
		Ot["f:pos:4"] = 0
		Ot["f:pos:5"] = -100

		Ot["tex_barre"] = "Interface\\PaperDollInfoFrame\\UI-Character-Skills-Bar" -- Texture des barres des boucliers
		Ot["f:tex:fond"] = "Interface\\Tooltips\\UI-Tooltip-Background" -- Texture du fond de la barre du fond
		Ot["f:tex:border"] = "Interface\\Tooltips\\UI-Tooltip-Border" -- Texture de la bordeure de la barre du fond
		Ot["font:val"] = "Fonts\\FRIZQT__.TTF" -- Text de la valeur des boucliers
	
		Ot["border:size"] = 5
		
		Ot["font:val:size"] = 18
		Ot["font:val:r"] = 0.8
		Ot["font:val:v"] = 1
		Ot["font:val:b"] = 0.9
		Ot["font:val:a"] = 1
		Ot["outline"] = false

		Ot["f:SBC:r"] = 1 -- Couleur du fond des barres
		Ot["f:SBC:v"] = 1
		Ot["f:SBC:b"] = 1
		Ot["f:SBC:a"] = 0.5
		
		Ot["border:size"] = 4
		Ot["insets:left"] = 2
		Ot["insets:right"] = 2
		Ot["insets:top"] = 2
		Ot["insets:bottom"] = 2

		Ot["b:a"] = 100

		Ot["1:r"] = 0 -- Couleur des barres des boucliers
		Ot["1:v"] = 0
		Ot["1:b"] = 1
		Ot["2:r"] = 1
		Ot["2:v"] = 1
		Ot["2:b"] = 1
		Ot["3:r"] = 1
		Ot["3:v"] = 0
		Ot["3:b"] = 0
		Ot["4:r"] = 1
		Ot["4:v"] = 1
		Ot["4:b"] = 0
		Ot["5:r"] = 1
		Ot["5:v"] = 0.95
		Ot["5:b"] = 0.77
		Ot["6:r"] = 0.8
		Ot["6:v"] = 1
		Ot["6:b"] = 1
		Ot["7:r"] = 1
		Ot["7:v"] = 0.7
		Ot["7:b"] = 0
		Ot["8:r"] = 0
		Ot["8:v"] = 0.7
		Ot["8:b"] = 0
		Ot["9:r"] = 0
		Ot["9:v"] = 0.7
		Ot["9:b"] = 0
		
end

------------------------------------------ Variables
------------------------------------------------------------------------------------

------------------------------------------ Tables bouclier
local B = {} -- Nom
local Bv = {0,0,0,0,0,0,0,0,0} -- Valeur
local Bmv = {0,0,0,0,0,0,0,0,0} -- Valeur max
local Bt = {0,0,0,0,0,0,0,0,0} -- Temps
local Bmt = {0,0,0,0,0,0,0,0,0} -- Temps max
local Blt = {0,0,0,0,0,0,0,0,0} -- Temps de lancement
local Bf = {0,0,0,0,0,0,0,0,0} -- Frames barres status bouclier
local Bf_tex = {0,0,0,0,0,0,0,0,0}
------
local Bvtar = {0,0,0,0,0,0,0,0,0} -- Valeur
local Bmvtar = {0,0,0,0,0,0,0,0,0} -- Valeur max
local Bttar = {0,0,0,0,0,0,0,0,0} -- Temps
local Bmttar = {0,0,0,0,0,0,0,0,0} -- Temps max
local Blttar = {0,0,0,0,0,0,0,0,0} -- Temps de lancement
local Bftar = {0,0,0,0,0,0,0,0,0} -- Frames barres status bouclier
local Bf_textar = {0,0,0,0,0,0,0,0,0}
------------------------------------------
local bg,blink,f,ft1,i1,i2 -- Frames
local bgtar,blinktar,ftar,ft1tar,i1tar,i2tar-- Frame target

local Bf_tex,color,color_tex,color_text = {},{},{},{}
local Bf_textar,colortar,color_textar,color_texttar = {},{},{},{}

local ordre,up_ordre,down_ordre,text_ordre,toggle_ordre,toggle_icon = {},{},{},{},{},{}


local slider,slidermoins,sliderplus = {},{},{}
local Sh_DDM,Sh_DDM_items,Sh_DDM_var,Sh_DDM_type,Sh_DDM_tar = {},{},{},{},{}
local cb,cbtar = {},{}
local btn = {}
local cp = {}
local i1_tex,i2_tex
local color_nom = ""
local color_fontval_tex,color_fontval_tex2,b_verr
local blinkbool = false

local totalmax,total
	
local slot = {}
for j=1,25 do
	slot[j] = {0,0,0,0,0,0,0,0,0,0,0,0}
end
	
	

------------------------------------------ Localisation
------------------------------------------------------------------------------------


local L = sh_Local
------------------------------------------------------------------------------------
local raptureTIME = 0


------------------------------------------ Tables
------------------------------------------------------------------------------------

------------------------------------------ Icons
local Btex = { "spell_ice_lament",  "spell_shadow_detectlesserinvisibility", "spell_shadow_sacrificialshield", "ability_paladin_blessedmending", "Spell_holy_PowerWordShield", "Spell_Holy_DevineAegis", "spell_holy_absolution", "ability_racial_cannibalize", "spell_deathknight_butcher2"}
for i=1,9 do Btex[i] =  "Interface\\Icons\\" .. Btex[i] end

local Bid = {11426, 1463, 7812, 85285, 17, 47753, 76669, 62600, 77535}

local B = {}
for i=1,9 do
	B[i] = GetSpellInfo(Bid[i])
end
------------------------------------------------------------------------------------






------------------------------------------ Fonctions
------------------------------------------------------------------------------------




------------------------------------------
function Sh_timer(self,elapsed)
   -- Fonction indépendante - met à jour le temps restant des boucliers
   ------------------------------------------
   timer = timer + elapsed

   if blinkbool then
   		if (timer >= 0.4 and timer <= 0.6) or timer >= 1 then
			blink:SetBackdropColor(1,0,0,0.5)
		elseif timer <= 0.4 or (timer >= 0.6 and timer <= 1) then 
			blink:SetBackdropColor(1,0,0,0)
		end
	else
		blink:SetBackdropColor(1,0,0,0)
	end
	
    if timer == 0.6 or timer >= 1.2 then
		if timer > 1.2 then
		timer = 0
		end
		--------------
		if GetTime() - raptureTIME > 12 then raptureFRAME:Hide() end
		Sh_OnEvent()
		--------------
	end
   
end      


------------------------------------------
function Sh_OnEvent()
   -- Appelé sur un UNIT_AURA
   ------------------------------------------
	if not(TESTMODE) then

	local function Sh_Shield(i,s)
		if s == nil then
			if O["Ord:toggle"][i] then
				Sh_newShield(i)
			else
				Bt[i]=0
				Bv[i]=0
				Bmv[i]=0
			end
		else
			if O["Ord:toggle"][i] then
				Sh_newShieldtar(i,s)
			else
				slot[s][i] = 0
				Bvtar[i],Bttar[i],Bmttar[i] = 0,0,0
				totalmax = totalmax + slot[s][i]
				total = total + Bvtar[i]
			end
		end
	end
	
	local unit = "player"

	if CLASS == "MAGE" then
		Sh_Shield(1)
		Sh_Shield(2)
		Sh_Shield(3)
	end
   	if CLASS == "WARLOCK" then
		Sh_Shield(3)
	end
	if CLASS == "PALADIN" then
		Sh_Shield(4)
	end
	if CLASS == "DEATHKNIGHT" then
		Sh_Shield(9)
	end
	if CLASS == "DRUID" then
		Sh_Shield(8)
	end
	Sh_Shield(5)
	Sh_Shield(6)
	Sh_Shield(7)
	
------------------------------------------



	local unit = "target"
	total,totalmax = 0,0
	local s = Sh_tar_slot(UnitName(unit))
	local _,classtar = UnitClass("target")
	if classtar == "MAGE" then
		Sh_Shield(1,s)
		Sh_Shield(2,s)
		Sh_Shield(3,s)
	end
   	if classtar == "WARLOCK" then
		Sh_Shield(3,s)
	end
	if classtar == "PALADIN" then
		Sh_Shield(4,s)
	end
	if classtar == "DEATHKNIGHT" then
		Sh_Shield(9,s)
	end
	if classtar == "DRUID" then
		Sh_Shield(8,s)
	end
	Sh_Shield(5,s)
	Sh_Shield(6,s)
	Sh_Shield(7,s)
   

	
	if total ~= 0 then
		slot[s][11] = UnitName(unit)
		slot[s][12] = GetTime()
		
	end
	Sh_tar_update(Bvtar,total,totalmax,Bttar,Bmttar)
end 
end

------------------------------------------   
function Sh_newShieldtar(i,s)
	-- 
	------------------------------------------   
	local unit = "target"
	local x1
	x1,_,_,_,_,Bmttar[i],Bttar[i] = UnitBuff(unit,B[i])
	Bvtar[i] = 0
	if x1 == nil then
		Bttar[i],Bmttar[i] = 0,0 
	else
		Bvtar[i] = Sh_val(unit,B[i])
	end
	-- temps,tempsmax,Val
	
	if Bvtar[i] == 0 then
		slot[s][i] = 0
	elseif slot[s][i] < Bvtar[i] then
		slot[s][i] = Bvtar[i]
	end
	totalmax = totalmax + slot[s][i]
	total = total + Bvtar[i]
end
	
------------------------------------------   
function Sh_tar_slot(name)
	-- Selectionne un slot libre ou celui déjà existant de la cible
	------------------------------------------
	if name ~= nil then
		for j=1,25 do
			if slot[j][11] == name then
				return j
			end
		end
	end
	
	for j=1,25 do
		if slot[j] == nil then
			return j
		end
	end

	for j=1,25 do
		if (GetTime()) - slot[j][12] > 60 then
		return j
		end
	end
	return 1
	

end



   

   
   
function Sh_tar_update(valB,valtotB,valmaxtotB,tempsB,tempsmaxB)
   -- met à jour la barre de la cible
   ------------------------------------------
   
 
   ---------------------------
   -- Si il n'y a aucun bouclier
   if valmaxtotB <= 1 then
		blinkbooltar = false
		blinktar:SetBackdropColor(1,0,0,0)
		ftar:Hide()
		ft1tar:SetText("")
      ---------------------------
      ---------------------------
      -- Si il y a des boucliers
   else
      
	local x5 = math.floor(valtotB / 1000)
	local x6 = (valtotB - (1000 * x5))
	if not(Ot["short"]) then
		if x5 == 0 then
			ft1tar:SetText(x6)
		elseif x6 >= 100 then
			ft1tar:SetText(x5 .. " " .. x6)
		elseif x6 >= 10 then 
			ft1tar:SetText(x5 .. " 0" .. x6) 
		else
			ft1tar:SetText(x5 .. " 00" .. x6)
		end
	else
		if x5 ~= 0 then
			ft1tar:SetText(x5 .. "k")
		else
			ft1tar:SetText(x6)
		end
	end		
		
      
      -- Blink ------
		if (valtotB / valmaxtotB) <= 0.20 then
			blinkbooltar = true
		else
			blinkbooltar = false
			blinktar:SetBackdropColor(1,0,0,0)
		end
	  
	  --------------- 
	  
	  
      ftar:Show()
      i1tar:Hide()
	  i2tar:Hide()
          
      local x1,x2,x3,x4 = 0,0,true,true
      
		for i,j in pairs(O["Ord"]) do
         	if valB[j] >= 1 and O["Ord:icon"][j] then
				if x3 then
					i1_textar:SetTexture(Btex[j])
					i1tar:Show()
					i1CDtar:SetCooldown(GetTime()-(tempsmaxB[j]-(tempsB[j] - GetTime())), tempsmaxB[j])
					x3 = false
				elseif x4 then
					i2_textar:SetTexture(Btex[j])
					i2tar:Show()
					i2CDtar:SetCooldown(GetTime()-(tempsmaxB[j]-(tempsB[j] - GetTime())), tempsmaxB[j])
					x4 = false
				end
		    end   
		end  
		
		for i,j in pairs(O["Ord"]) do
			if valB[j] >= 1 then
				if not(x4) then 
					x2=(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))/(valmaxtotB/valB[j])
					fbtar:SetPoint("LEFT",Ot["iconsize"]*2+Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
					fb2tar:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
					
				elseif not(x3) then
					x2=(Ot["f:largeur"]-(Ot["iconsize"] + Ot["insets:left"]+Ot["insets:right"]))/(valmaxtotB/valB[j])
					fbtar:SetPoint("LEFT",Ot["iconsize"]+Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"] + Ot["insets:left"]+Ot["insets:right"]))
					fb2tar:SetPoint("LEFT",Ot["iconsize"] +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"] + Ot["insets:left"]+Ot["insets:right"]))
				else
					x2=(Ot["f:largeur"]-(Ot["insets:left"]+Ot["insets:right"]))/(valmaxtotB/valB[j])
					fbtar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fbtar:SetWidth(Ot["f:largeur"]-(Ot["insets:left"]+Ot["insets:right"]))
					fb2tar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
					fb2tar:SetWidth(Ot["f:largeur"]-(Ot["insets:left"]+Ot["insets:right"]))
				end
				Bftar[j]:Show()
				Bftar[j]:SetWidth(x2)
				Bftar[j]:SetPoint("LEFT",x1,0)
			else
				Bftar[j]:SetWidth(1)
				Bftar[j]:Hide()
			end
			x1 = x1 + x2
			x2 = 0
		end
   end
end  
   
   
   
   
   
   
   
   
 
 ------------------------------------------------------------------------------------  
------------------------------------------   
function Sh_newShield(i)
--
------------------------------------------   
	local unit = "player"
	if Sh_check_buff(unit,B[i],i) then
		if Bmv[i] == 0 then
		f:Show()
		Bt[i] = Bmt[i]
		Bmv[i] = Bv[i]
		end
	end
	if Bv[i]/100000 >= Bmv[i]/100000 then --WTF? Fix, ne fonctionnait pas pour des valeurs de bouclier > 10 k ...
		Bmv[i] = Bv[i]
	end
	Sh_update(unit,B[i],i)
end

   
 

------------------------------------------
function Sh_check_buff(unit,nom,i)
   -- Test si le buff est présent sur unit
   ------------------------------------------
   	local temp,_,_,_,_,x1,x2 = UnitBuff(unit,nom)
	if (temp ==  nil) then
		Bv[i] = 0
		Bmv[i] =  0
		return false
	else
		Bt[i] = x2 - GetTime()
		Bmt[i] = x1
		Bv[i] = Sh_val(unit,nom)
		return true
	end
end


------------------------------------------
function Sh_val(unit, nom)
   -- Lis la valeur du bouclier dans le tooltip
   ------------------------------------------  
   
   
   MiowTooltip:ClearLines()
   MiowTooltip:SetUnitBuff(unit,nom)
   
   local val = tostring(_G["MiowTooltipTextLeft"..2]:GetText())
   val = string.match(val,"%d+")
   
   
   return tonumber(val)
end



------------------------------------------
function Sh_update(unit,nom,i)
   -- met à jour la barre
   ------------------------------------------
   
   
   ---------------------------
   local uBmv,uBv = 0,0
   for j=1,table.getn(Bmv) do
      uBmv = uBmv + Bmv[j]
   end
   for j=1,table.getn(Bv) do
      uBv = uBv + Bv[j]
   end
   ---------------------------
   
   ---------------------------
   -- Si il n'y a aucun bouclier
	if uBmv < 1 or uBmv == nil then
		blinkbool = false
		f:Hide()
		ft1:SetText("")
      ---------------------------
      ---------------------------
      -- Si il y a des boucliers
	else
      
	local x5 = math.floor(uBv / 1000)
	local x6 = (uBv - (1000 * x5))
	if not(O["short"]) then
		if x5 == 0 then
			ft1:SetText(x6)
		elseif x6 >= 100 then
			ft1:SetText(x5 .. " " .. x6)
		elseif x6 >= 10 then 
			ft1:SetText(x5 .. " 0" .. x6) 
		else
			ft1:SetText(x5 .. " 00" .. x6)
		end
	else
		if x5 ~= 0 then
			ft1:SetText(x5 .. "k")
		else
			ft1:SetText(x6)
		end
	end		
		
		
		
		
      
      -- Blink ------
		if (uBv / uBmv) <= 0.20 then
			blinkbool = true
		else
			blinkbool = false
			blink:SetBackdropColor(1,0,0,0)
		end
	  
	  --------------- 
	  
	  
      f:Show()
      i1:Hide()
	  i2:Hide()
      icon1,icon2 = 0,0
      
      local x1,x2,x3,x4 = 0,0,true,true
      
		for i,j in pairs(O["Ord"]) do
         	if Bv[j] >= 1 and O["Ord:icon"][j] then
				if x3 then
					i1_tex:SetTexture(Btex[j])
					i1:Show()
					i1CD:SetCooldown(GetTime()-(Bmt[j]-Bt[j]), Bmt[j])
					x3 = false
				elseif x4 then
					i2_tex:SetTexture(Btex[j])
					i2:Show()
					i2CD:SetCooldown(GetTime()-(Bmt[j]-Bt[j]), Bmt[j])
					x4 = false
				end
		    end   
		end  
		
		x1 = 0
		for i,j in pairs(O["Ord"]) do
			if Bv[j] >= 1 then
				if not(x4) then 
					x2=(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))/(uBmv/Bv[j])
					fb:SetPoint("LEFT",O["iconsize"]*2+O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
					fb2:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb2:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
					
				elseif not(x3) then
					x2=(O["f:largeur"]-(O["iconsize"] + O["insets:left"]+O["insets:right"]))/(uBmv/Bv[j])
					fb:SetPoint("LEFT",O["iconsize"]+O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb:SetWidth(O["f:largeur"]-(O["iconsize"] + O["insets:left"]+O["insets:right"]))
					fb2:SetPoint("LEFT",O["iconsize"] +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb2:SetWidth(O["f:largeur"]-(O["iconsize"] + O["insets:left"]+O["insets:right"]))
				else
					x2=(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))/(uBmv/Bv[j])
					fb:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb:SetWidth(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))
					fb2:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
					fb2:SetWidth(O["f:largeur"]-(O["insets:left"]+O["insets:right"]))
				end
				Bf[j]:Show()
				Bf[j]:SetWidth(x2)
				Bf[j]:SetPoint("LEFT",x1,0)
			else
				Bf[j]:SetWidth(1) Bf[j]:Hide()
			end
			x1 = x1 + x2   
			x2 = 0
		end
   end
end




------------------------------------------------------------------------------------



------------------------------------------ Fonctions Frames
------------------------------------------------------------------------------------
function Sh_createFrame(nom,parent,hauteur,largeur)
   --Crée une Frame, tout simplement
   ------------------------------------------
   local ff = CreateFrame("Frame",nom,parent)
   ff:SetFrameStrata("MEDIUM")
   ff:SetWidth(largeur)
   ff:SetHeight(hauteur)
   
    
   return ff   
end
------------------------------------------


------------------------------------------
function Sh_createBar()
   -- Crée les frames nécessaires à l'affichage de l'addon
   -----------------------------------------
   -- Conteneur
	bg = CreateFrame("Frame","Sh_bg_container",UIParent)
	bg:SetFrameStrata("MEDIUM")
	bg:SetWidth(O["f:largeur"])
	bg:SetHeight(O["f:hauteur"])
	bg:SetBackdrop({bgFile = O["f:tex:fond"] })
	bg:SetBackdropColor(0,0,0,0)
	bg:SetFrameLevel(O["level"])
	bg:Show()
   
	blink = CreateFrame("Frame","Sh_blink_blink",bg)
	blink:SetFrameStrata("MEDIUM")
	blink:SetAllPoints(bg)
	blink:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background" })
	blink:SetFrameLevel(O["level"] + 10)
   
   
   
   -- Frame du fond
	f = CreateFrame("Frame","Sh_f_fond",bg)
	f:SetFrameStrata("MEDIUM")
	f:SetWidth(O["f:largeur"])
	f:SetHeight(O["f:hauteur"])
	f:SetBackdrop({bgFile = O["f:tex:fond"], 
         edgeFile = O["f:tex:border"],
         edgeSize = O["border:size"],
		 insets = {
		 left = O["insets:left"],
		 right = O["insets:right"],
		 top = O["insets:top"],
		 bottom = O["insets:bottom"],
		 },})
	f:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"]);
	f:SetPoint("CENTER",0,0)
   -----------------------------------------
   -- Extase
   	raptureFRAME = Sh_createFrame("Sh_raptureFRAME_raptureIcon",bg,O["iconsize"],O["iconsize"])
	raptureFRAME:SetPoint("LEFT",-O["iconsize"] -O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	raptureTEX = raptureFRAME:CreateTexture(nil,"BACKGROUND")
	raptureTEX:SetAllPoints(raptureFRAME)
	raptureTEX:SetTexture("Interface\\Icons\\spell_holy_rapture")
	raptureCD = CreateFrame("Cooldown","raptureFRAMECD",raptureFRAME)
	raptureCD:SetAllPoints(raptureFRAME)
	raptureFRAME:Hide()
	
   -----------------------------------------
   -- Frame des icones
	i1 = Sh_createFrame("Sh_i1_icon1",f,O["iconsize"],O["iconsize"])
	i1:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	i1_tex = i1:CreateTexture(nil,"BACKGROUND")
	i1_tex:SetAllPoints(i1)
	i1_tex:SetTexture("Interface\\Icons\\trade_engineering")
	i1CD = CreateFrame("Cooldown","i1CD",i1)
	i1CD:SetAllPoints(i1)   
   
   
	i2 = Sh_createFrame("Sh_i2_icon2",f,O["iconsize"],O["iconsize"])
	i2:SetPoint("LEFT",O["iconsize"] +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	i2_tex = i2:CreateTexture(nil,"BACKGROUND")
	i2_tex:SetAllPoints(i2)
	i2_tex:SetTexture("Interface\\Icons\\trade_engineering")
	i2CD = CreateFrame("Cooldown","i2CD",i2)
	i2CD:SetAllPoints(i2)
   
   ----------------------------------  
   -- Frame du fond des barres
   fb = Sh_createFrame("Sh_fb_fondBarres",f,O["f:hauteur"] - (O["insets:top"] + O["insets:bottom"]),O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
   fb:SetFrameStrata("MEDIUM")
   fb:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
   fb:Show()
   
   fb2 = Sh_createFrame("Sh_fb2_fondBarreLevel9",f,O["f:hauteur"] -(O["insets:top"] + O["insets:bottom"]),O["f:largeur"]-(O["iconsize"]*2 +O["insets:left"]+O["insets:right"]))
   fb2:SetFrameStrata("MEDIUM")
   fb2:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
   fb2:Show()
   fb2:SetFrameLevel(O["level"] + 9)
   
   -----------------------------------------  
   -- Frame de la barre de vie du bouclier
   
   for j=1,9 do
       	Bf[j] = CreateFrame("Frame","Sh_Bf" .. j .. "_Barre",fb)
		Bf[j]:SetFrameStrata("MEDIUM")
		Bf[j]:SetWidth(0)
		Bf[j]:SetHeight(O["f:hauteur"] -(O["insets:top"] + O["insets:bottom"]),0)
		Bf[j]:SetPoint("LEFT",0,0)
		Bf[j]:Show()
		
		Bf_tex[j] = Bf[j]:CreateTexture(nil,"BACKGROUND")
		Bf_tex[j]:SetTexture(O["tex_barre"])
		Bf_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
		Bf_tex[j]:SetAllPoints(Bf[j])
      
   end
   
   
   -- Texte de la valeur et du pourcentage du bouclier
   ft1 = fb2:CreateFontString("Sh_ft1_texteVal","MEDIUM")
   ft1:SetFont(O["font:val"], O["font:val:size"])
   ft1:SetText("")
   ft1:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
   ft1:SetPoint("CENTER", 0, 0)
   ft1:Show()
   
   
   
   
   
   
   
   ----------------------------------------------------------------------------------------
   
      -- Crée les frames nécessaires à l'affichage de l'addon
   -----------------------------------------
   -- Conteneur
	bgtar = CreateFrame("Frame","Sh_bgtar_container",UIParent)
	bgtar:SetFrameStrata("MEDIUM")
	bgtar:SetWidth(Ot["f:largeur"])
	bgtar:SetHeight(Ot["f:hauteur"])
	bgtar:SetBackdrop({bgFile = Ot["f:tex:fond"] })
	bgtar:SetBackdropColor(0,0,0,0)
	bgtar:SetFrameLevel(Ot["level"])
	bgtar:Show()
   
	blinktar = CreateFrame("Frame","Sh_blinktar_blink",bgtar)
	blinktar:SetFrameStrata("MEDIUM")
	blinktar:SetAllPoints(bgtar)
	blinktar:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background"})
	blinktar:SetBackdropColor(1,0,0,0)
	blinktar:SetFrameLevel(Ot["level"] + 10)
   
   
   
   -- Frame du fond
	ftar = CreateFrame("Frame","Sh_ftar_fond",bgtar)
	ftar:SetFrameStrata("MEDIUM")
	ftar:SetWidth(Ot["f:largeur"])
	ftar:SetHeight(Ot["f:hauteur"])
	ftar:SetBackdrop({bgFile = Ot["f:tex:fond"], 
         edgeFile = Ot["f:tex:border"],
         edgeSize = Ot["border:size"],
		 insets = {
		 left = Ot["insets:left"],
		 right = Ot["insets:right"],
		 top = Ot["insets:top"],
		 bottom = Ot["insets:bottom"],
		 },})
	ftar:SetBackdropColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"]);
	ftar:SetPoint("CENTER",0,0)

	
   -----------------------------------------
   -- Frame des icones
	i1tar = Sh_createFrame("Sh_i1tar_icon1",ftar,Ot["iconsize"],Ot["iconsize"])
	i1tar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	i1_textar = i1tar:CreateTexture(nil,"BACKGROUND")
	i1_textar:SetAllPoints(i1tar)
	i1_textar:SetTexture("Interface\\Icons\\trade_engineering")
	i1CDtar = CreateFrame("Cooldown","i1CDtar",i1tar)
	i1CDtar:SetAllPoints(i1tar)   
   
   
	i2tar = Sh_createFrame("Sh_i2tar_icon2",ftar,Ot["iconsize"],Ot["iconsize"])
	i2tar:SetPoint("LEFT",Ot["iconsize"] +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	i2_textar = i2tar:CreateTexture(nil,"BACKGROUND")
	i2_textar:SetAllPoints(i2tar)
	i2_textar:SetTexture("Interface\\Icons\\trade_engineering")
	i2CDtar = CreateFrame("Cooldown","i2CDtar",i2tar)
	i2CDtar:SetAllPoints(i2tar)
   
   ----------------------------------  
   -- Frame du fond des barres
   fbtar = Sh_createFrame("Sh_fbtar_fondBarres",ftar,Ot["f:hauteur"] - (Ot["insets:top"]+Ot["insets:bottom"]),Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
   fbtar:SetFrameStrata("MEDIUM")
   fbtar:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
   fbtar:Show()
   
   fb2tar = Sh_createFrame("Sh_fb2tar_fondBarreLevel9",ftar,Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]),Ot["f:largeur"]-(Ot["iconsize"]*2 +Ot["insets:left"]+Ot["insets:right"]))
   fb2tar:SetFrameStrata("MEDIUM")
   fb2tar:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
   fb2tar:Show()
   fb2tar:SetFrameLevel(Ot["level"] + 9)
   
   -----------------------------------------  
   -- Frame de la barre de vie du bouclier
   
   for j=1,9 do
       	Bftar[j] = CreateFrame("Frame","Sh_Bftar" .. j .. "_Barre",fbtar)
		Bftar[j]:SetFrameStrata("MEDIUM")
		Bftar[j]:SetWidth(0)
		Bftar[j]:SetHeight(Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]))
		--Bftar[j]:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
		Bftar[j]:Show()
		
		Bf_textar[j] = Bftar[j]:CreateTexture(nil,"BACKGROUND")
		Bf_textar[j]:SetTexture(Ot["tex_barre"])
		Bf_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
		Bf_textar[j]:SetAllPoints(Bftar[j])
      
   end
   
   
   -- Texte de la valeur et du pourcentage du bouclier
   ft1tar = fb2tar:CreateFontString("Sh_ft1tar_texteVal","MEDIUM")
   ft1tar:SetFont(Ot["font:val"], Ot["font:val:size"])
   ft1tar:SetText("")
   ft1tar:SetTextColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
   ft1tar:SetPoint("CENTER", 0, 0)
   ft1tar:Show()
   
end





function Sh_refresh()
	
	if cb[5]:GetChecked() then O["contour"] = true else O["contour"] = false end
	if cbtar[5]:GetChecked() then Ot["contour"] = true else Ot["contour"] = false end
	
	O["enable"] = cb[1]:GetChecked()
	O["enable_extase"] = cb[2]:GetChecked()
	if O["enable"] then bg:Show() else bg:Hide() end
	O["short"] = cb[3]:GetChecked()


	bg:SetPoint(O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"])
	bg:SetWidth(O["f:largeur"])
	bg:SetHeight(O["f:hauteur"])
	bg:SetFrameLevel(O["level"])

	f:SetWidth(O["f:largeur"])
	f:SetHeight(O["f:hauteur"])
	f:SetBackdrop({bgFile = O["f:tex:fond"], 
		edgeFile = O["f:tex:border"],
		edgeSize = O["border:size"],
		insets = {
		left = O["insets:left"],
		right = O["insets:right"],
		top = O["insets:top"],
		bottom = O["insets:bottom"],
		},})
	f:SetBackdropColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
   
   
	raptureFRAME:SetWidth(O["iconsize"])
	raptureFRAME:SetHeight(O["iconsize"])
	i1:SetWidth(O["iconsize"])
	i1:SetHeight(O["iconsize"])
	i1:SetPoint("LEFT",O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	i2:SetWidth(O["iconsize"])
	i2:SetHeight(O["iconsize"])
	i2:SetPoint("LEFT",O["iconsize"] +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))

	fb:SetWidth(O["f:largeur"]-(O["iconsize"]*2 +O["insets:left"]+O["insets:right"]))
	fb:SetPoint("LEFT",(O["iconsize"]*2 +O["insets:left"]),((O["insets:bottom"]-O["insets:top"])/2))
	fb2:SetWidth(O["f:largeur"]-(O["iconsize"]*2 +O["insets:left"]+O["insets:right"]))
	fb2:SetPoint("LEFT",(O["iconsize"]*2 +O["insets:left"]),((O["insets:bottom"]-O["insets:top"])/2))



	ft1:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	if O["contour"] then outline = "OUTLINE" else outline = nil end
	ft1:SetFont(O["font:val"], O["font:val:size"],outline)


   
   
   
	--------------------------------------------------------------------------------
   
   
	Ot["enable"] = cbtar[1]:GetChecked()
	if Ot["enable"] then bgtar:Show() else bgtar:Hide() end
	Ot["short"] = cbtar[3]:GetChecked()

	bgtar:SetPoint(Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"])
	bgtar:SetWidth(Ot["f:largeur"])
	bgtar:SetHeight(Ot["f:hauteur"])
	bgtar:SetFrameLevel(Ot["level"])

	ftar:SetWidth(Ot["f:largeur"])
	ftar:SetHeight(Ot["f:hauteur"])
	ftar:SetBackdrop({bgFile = Ot["f:tex:fond"], 
		edgeFile = Ot["f:tex:border"],
		edgeSize = Ot["border:size"],
		insets = {
		left = Ot["insets:left"],
		right = Ot["insets:right"],
		top = Ot["insets:top"],
		bottom = Ot["insets:bottom"],
		},})
	ftar:SetBackdropColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"])



	i1tar:SetWidth(Ot["iconsize"])
	i1tar:SetHeight(Ot["iconsize"])
	i1tar:SetPoint("LEFT",Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	i2tar:SetWidth(Ot["iconsize"])
	i2tar:SetHeight(Ot["iconsize"])
	i2tar:SetPoint("LEFT",Ot["iconsize"] +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))

	fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 +Ot["insets:left"]+Ot["insets:right"]))
	fbtar:SetPoint("LEFT",(Ot["iconsize"]*2 +Ot["insets:left"]),((Ot["insets:bottom"]-Ot["insets:top"])/2))
	fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 +Ot["insets:left"]+Ot["insets:right"]))
	fb2tar:SetPoint("LEFT",(Ot["iconsize"]*2 +Ot["insets:left"]),((Ot["insets:bottom"]-Ot["insets:top"])/2))

	
	ft1tar:SetTextColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	if Ot["contour"] then outline = "OUTLINE" else outline = nil end
	ft1tar:SetFont(Ot["font:val"], Ot["font:val:size"], outline)

	   local tex
	for j=1,9 do
		Bf_tex[j]:SetTexture(O["tex_barre"])
		Bf_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"],(O["b:a"]/100))

		--Bf[j]:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
		Bf[j]:SetHeight(O["f:hauteur"] -(O["insets:top"]+O["insets:bottom"]))

		Bf_textar[j]:SetTexture(Ot["tex_barre"])
		Bf_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"],(Ot["b:a"]/100))

		--Bftar[j]:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
		Bftar[j]:SetHeight(Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]))
		
		
		
		color_tex[j]:SetTexture(O["tex_barre"])
		color_textar[j]:SetTexture(Ot["tex_barre"])
		
		if O["contour"] then outline = "OUTLINE" else outline = nil end
		color_text[j]:SetFont(O["font:val"],12,outline)
		color_text[j]:SetTextColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
		
		if Ot["contour"] then outline = "OUTLINE" else outline = nil end
		color_texttar[j]:SetFont(Ot["font:val"],12,outline)
		color_texttar[j]:SetTextColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	end
    
	-------- Refresh ColorPicker
		
	color_fontval_tex:SetVertexColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	
	color_fontval_tex2:SetTexture(O["f:tex:fond"])
	color_fontval_tex2:SetVertexColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
			
	color_fontval_textar:SetVertexColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	
	color_fontval_tex2tar:SetTexture(Ot["f:tex:fond"])
	color_fontval_tex2tar:SetVertexColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"])
	
    
	
	
	-- Refresh ordre :
	for i,j in pairs(O["Ord"]) do
		ordre[j]:SetPoint("LEFT",20,135-(30*i))
		toggle_ordre[j]:SetChecked(O["Ord:toggle"][j])
	end
	
   	Sh_test()
	Sh_OnEvent()
end



function Sh_refresh_options()
--------- Refresh des options
	local function slider_refresh(nb,var)
	slider[nb]:SetValue(var)
	getglobal(slider[nb]:GetName() .. 'Text'):SetText(var)
	end
	slider_refresh(1,O["b:a"])
	slider_refresh(2,O["font:val:size"])
	slider_refresh(3,O["f:largeur"])
	slider_refresh(4,O["f:hauteur"])
	slider_refresh(5,O["border:size"])
	slider_refresh(6,O["iconsize"])
	slider_refresh(7,O["level"])
	
	slider_refresh(21,Ot["b:a"])
	slider_refresh(22,Ot["font:val:size"])
	slider_refresh(23,Ot["f:largeur"])
	slider_refresh(24,Ot["f:hauteur"])
	slider_refresh(25,Ot["border:size"])
	slider_refresh(26,Ot["iconsize"])
	slider_refresh(27,Ot["level"])

	
	slider_refresh(10,O["insets:left"])
	slider_refresh(11,O["insets:right"])
	slider_refresh(12,O["insets:top"])
	slider_refresh(13,O["insets:bottom"])
	
	slider_refresh(30,Ot["insets:left"])
	slider_refresh(31,Ot["insets:right"])
	slider_refresh(32,Ot["insets:top"])
	slider_refresh(33,Ot["insets:bottom"])
	
	cb[5]:SetChecked(O["contour"])
	cbtar[5]:SetChecked(Ot["contour"])
	
	
	local function DDM_set(nb,item,var,type)
		local idcheck = 1
		for j=1,table.getn(item) do
			if O[var] == LSM:Fetch(type,item[j]) and nb<20 then
				idcheck = j
			elseif Ot[var] == LSM:Fetch(type,item[j]) and nb>20 then
				idcheck = j
			end
		end
		
		UIDropDownMenu_SetSelectedValue(Sh_DDM[nb], idcheck)
	end
	
	DDM_set(1,M_statusbar,"tex_barre","statusbar")
	DDM_set(2,M_font,"font:val","font")
	DDM_set(3,M_border,"f:tex:border","border")
	DDM_set(4,M_background,"f:tex:fond","background")

	DDM_set(21,M_statusbar,"tex_barre","statusbar")
	DDM_set(22,M_font,"font:val","font")
	DDM_set(23,M_border,"f:tex:border","border")
	DDM_set(24,M_background,"f:tex:fond","background")
	
	
	----------
	for j=1,9 do
		color_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
		color_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
	end
end
























------------------------------------------------------------------------------------
------------------------------------------ OPTION LOAD

function Sh_opt_LOAD()
	
	local x1 = true
	if ShieldHealth_SV == nil and ShieldHealth_SV2 == nil then
		ShieldHealth_SV = O
		ShieldHealth_SV2 = Ot
	end
	
	O = ShieldHealth_SV 
	Ot = ShieldHealth_SV2
	if ShieldHealth_SV["version"] == 2 then ShieldHealth_SV["version"] = 1 end -- fix erreur numero version dans la v1
		

	if ShieldHealth_SV["version"] ~= nil then
		if ShieldHealth_SV["version"] >= version then
			x1 = false
		end
	end
	
	
	if x1 then
		----- v1.1
		O["Ord"] = {1,2,3,4,5,6,7,8,9}
		O["Ord:toggle"] = {true,true,true,true,true,true,true,true,true}
		O["Ord:icon"] = {true,true,true,true,true,true,true,true,true}
		
		O["insets:left"] = O["border:size"]
		O["insets:right"] = O["border:size"]
		O["insets:top"] = O["border:size"]
		O["insets:bottom"] = O["border:size"]
		O["border:size"] = 12
		O["outline"] = false
		
		Ot["insets:left"] = Ot["border:size"]
		Ot["insets:right"] = Ot["border:size"]
		Ot["insets:top"] = Ot["border:size"]
		Ot["insets:bottom"] = Ot["border:size"]
		Ot["border:size"] = 12
		Ot["outline"] = false
		------
		
		
		ShieldHealth_SV["version"] = version
	end

	Sh_opt()
	Sh_refresh()
	
end






function Sh_opt_OK()
   ShieldHealth_SV = O
   ShieldHealth_SV2 = Ot
end










------------------------------------------------------------------------------------




function Sh_EventFrame_OnEvent(self, event, ...)
   Sh_OnEvent()
end

function Sh_EventFrame3_OnEvent(self, ...)
		local _,_,TYPE,_,_,_,_,_,_,TARGET,_,_,SPELLID,_,_,_,VAL = select(1, ...)
	if O["enable_extase"] then
		local _,_,_,_,_,Target,_,_,_,_,_,_,SpellID = select(1, ...)
		if SpellID == 47755 and Target == UnitName("player") then
			raptureFRAME:Show()
			raptureTIME = GetTime()
			raptureCD:SetCooldown(raptureTIME,12)
		end
	end
	
	if SPELLID and VAL then
		local x1,x2 = false,0
		for j=1,9 do
			if SPELLID == Bid[j] then x1 = true; x2 = j; break; end
		end
		if x1 then
			local s = Sh_tar_slot(TARGET)
			
			if TYPE == "SPELL_AURA_APPLIES" then
				slot[s][x2] = VAL
				slot[s][11] = TARGET
			elseif TYPE == "SPELL_AURA_REFRESH" then
				if slot[s][x2] < VAL then
					slot[s][x2] = VAL
					slot[s][11] = TARGET
				end
			elseif TYPE == "SPELL_AURA_REMOVED" then
				slot[s][x2] = VAL
				slot[s][11] = TARGET
			end
		end
	end 
end












------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
-------------------------------------]]--[[-----------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ MENU DANS INTERFACE>ADDONS
function Sh_opt_menu()
   -- Crée le menu des options
   ------------------------------------------
	ShieldHealth = {};
	ShieldHealth.panel = CreateFrame( "Frame", "ShieldHealthPanel", UIParent);
	ShieldHealth.panel.name = "Shield Health";
	InterfaceOptions_AddCategory(ShieldHealth.panel);
	ShieldHealth.panel.okay = function ()  Sh_opt_OK() end
	ShieldHealth.panel.cancel = function () Sh_opt_OK() end
	ShieldHealth.panel.default = function ()  Sh_opt_OK() end



	ShieldHealth.childpanel_player = CreateFrame( "Frame", "ShieldHealthChildPlayer", ShieldHealth.panel);
	ShieldHealth.childpanel_player.name = L["Joueur"];
	ShieldHealth.childpanel_player.parent = ShieldHealth.panel.name;
	InterfaceOptions_AddCategory(ShieldHealth.childpanel_player);
	
	ShieldHealth.childpanel_target = CreateFrame( "Frame", "ShieldHealthChildTarget", ShieldHealth.panel);
	ShieldHealth.childpanel_target.name = L["Cible"];
	ShieldHealth.childpanel_target.parent = ShieldHealth.panel.name;
	InterfaceOptions_AddCategory(ShieldHealth.childpanel_target);
	
	ShieldHealth.childpanel_ordre = CreateFrame( "Frame", "ShieldHealthChildOrdre", ShieldHealth.panel);
	ShieldHealth.childpanel_ordre.name = L["Ordre"];
	ShieldHealth.childpanel_ordre.parent = ShieldHealth.panel.name;
	InterfaceOptions_AddCategory(ShieldHealth.childpanel_ordre);
end


------------------------------------------------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ SLIDER
function Sh_opt_createSlider(nb,nom,parent,val,min,max,var,lock,unit)
   -- Règle les options du slider
   ------------------------------------------
   slider[nb] = CreateFrame("Slider", nom, parent, "OptionsSliderTemplate")
   slider[nb]:ClearAllPoints()
   slider[nb]:SetMinMaxValues(min,max)
   slider[nb]:SetValue(val)
   slider[nb]:SetWidth(125)
   getglobal(slider[nb]:GetName() .. 'Low'):SetText(min);
   getglobal(slider[nb]:GetName() .. 'High'):SetText(max);
   getglobal(slider[nb]:GetName() .. 'Text'):SetText(val);   
   slider[nb]:SetValueStep(1)
   slider[nb]:Show()
   
   
   slidermoins[nb] = CreateFrame("Button", "btn-_" .. nom, slider[nb], "UIPanelButtonTemplate2")
   slidermoins[nb]:SetPoint("LEFT", -33, 0)
   slidermoins[nb]:SetText("-")
   slidermoins[nb]:SetScript("OnClick",function() slider[nb]:SetValue(slider[nb]:GetValue()-1) Sh_opt_sliderUpdate(nb,var,unit) end)
   slidermoins[nb]:SetWidth (17)
   slidermoins[nb]:Show()
   
   sliderplus[nb] = CreateFrame("Button", "btn+_" .. nom, slider[nb], "UIPanelButtonTemplate2")
   sliderplus[nb]:SetPoint("LEFT", -19, 0)
   sliderplus[nb]:SetText("+")
   sliderplus[nb]:SetScript("OnClick",function() slider[nb]:SetValue(slider[nb]:GetValue()+1) Sh_opt_sliderUpdate(nb,var,unit) end)
   sliderplus[nb]:SetWidth(17)
   sliderplus[nb]:Show()
   
   -- met à jour la valeur au dessus su slider
   slider[nb]:SetScript("OnValueChanged", function() Sh_opt_sliderUpdate(nb,var,unit) end)
   
   -- permet de 'dévérouiller' le slider
   if not(lock) then
      slider[nb]:SetScript("OnMouseUp",  function() Sh_opt_sliderVal(nb) end)
   end
   
end

function Sh_opt_sliderUpdate(nb,var,unit)
   local sliderval =  math.ceil(slider[nb]:GetValue())
   getglobal(slider[nb]:GetName() .. 'Text'):SetText(sliderval)
   if unit then Ot[var] = sliderval else O[var] = sliderval end
   Sh_refresh() 
end

function Sh_opt_sliderVal(nb)
   local slideval =  math.ceil(slider[nb]:GetValue())
   slider[nb]:SetMinMaxValues(slideval-100,slideval+100)
   slider[nb]:SetValue(slideval)
   getglobal(slider[nb]:GetName() .. 'Low'):SetText(slideval-100)
   getglobal(slider[nb]:GetName() .. 'High'):SetText(slideval+100)
end

------------------------------------------
function Sh_opt_Slider(slider,val,min,max)
   -- retourne la valeur de slider ou le met aux valeurs précisés
   ------------------------------------------
   if val then
      slider:SetMinMaxValues(min,max)
      slider:SetValue(val)
      getglobal(slider:GetName() .. 'Low'):SetText(min)
      getglobal(slider:GetName() .. 'High'):SetText(max)
      Slider:SetValueStep(1)
   else 
      return  math.ceil(slider:GetValue())
   end
end

------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ CHECKBOX
function Sh_opt_createCheckbox(nom,texte,parent)
   -- règles les options de la checkbox
   ------------------------------------------
   local cbtemp = CreateFrame("CheckButton", nom, parent, "UICheckButtonTemplate")
   cbtemp:ClearAllPoints()
   _G[nom .. "Text"]:SetText(texte)
   _G[nom .. "Text"]:SetTextColor(1,1,1,1)
   cbtemp:SetScript("OnClick", function()
			Sh_refresh()
		end
   )
   
   
   return cbtemp
end


------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ DROP DOWN MENU
function Sh_opt_createDDM(nom,parent,largeur,items,var,type,tar)
   -- Crée un Drop Down menu
   ------------------------------------------
   	Sh_DDM_items[nom] = items
	Sh_DDM_var[nom] = var
	Sh_DDM_type[nom] = type
	Sh_DDM_tar[nom] = tar
	
	Sh_DDM[nom] = CreateFrame("Frame", "DDM" .. nom, parent, "UIDropDownMenuTemplate")
   
	Sh_DDM[nom]:ClearAllPoints()
	Sh_DDM[nom]:Show()
	
	
	local function Sh_opt_DDMOnClick(self,x1,n)
		
		local ID = self:GetID()
		if x1 == 1 then
			ID = ID + 20
		elseif n > 20 then
			ID = ID - 1
		end
		UIDropDownMenu_SetSelectedValue(Sh_DDM[nom], ID)
		
		-----------
		if tar then Ot[var] = LSM:Fetch(type,items[ID]) else
		O[var] = LSM:Fetch(type,items[ID]) end
		Sh_refresh()
		-----------
	end
	
	local function Sh_opt_DDMinitialize(self, level)
		local info = UIDropDownMenu_CreateInfo()
		local i = 1
		
		if table.getn(items) > 20 and level == 1 then
			info = UIDropDownMenu_CreateInfo()
			info.hasArrow = true; 
			info.notCheckable = true;
			info.text = L["plus"]
			UIDropDownMenu_AddButton(info, 1)
		end

		for k, v in pairs(items) do
			
			if i <= 20 and level == 1 then
				info = UIDropDownMenu_CreateInfo()
				info.text = v
				info.value = i
				info.arg1 = 0
				info.arg2 = table.getn(items)
				info.func = Sh_opt_DDMOnClick
				UIDropDownMenu_AddButton(info, 1)
			elseif i > 20 and level == 2 then
				info = UIDropDownMenu_CreateInfo()
				info.text = v
				info.value = i
				info.arg1 = 1
				info.arg2 = table.getn(items)
				info.func = Sh_opt_DDMOnClick
				UIDropDownMenu_AddButton(info, 2)
			end
			i = i + 1
		end
		

	end
	

	
	UIDropDownMenu_Initialize(Sh_DDM[nom], Sh_opt_DDMinitialize)
	UIDropDownMenu_SetWidth(Sh_DDM[nom], largeur);
	UIDropDownMenu_SetButtonWidth(Sh_DDM[nom], 124)
	UIDropDownMenu_JustifyText(Sh_DDM[nom], "LEFT")
	
	local idcheck = 1
	for j=1,table.getn(items) do
		if Ot[var] == LSM:Fetch(type,items[j]) and tar then
			 idcheck = j
			 break
		elseif O[var] == LSM:Fetch(type,items[j]) and not(tar) then
			 idcheck = j
			 break
		end
	end
	if table.getn(items) > 20 then
		if idcheck < 20 then
			idcheck = idcheck - 1
		end
	end
	UIDropDownMenu_SetSelectedValue(Sh_DDM[nom], idcheck)
	

   
end





	
------------------------------------------
------------------------------------------------------------------------------------
------------------------------------------ COLOR PICKER

------------------------------------------
function Sh_opt_showCP(r, v, b, a, Sh_opt_CPCallback,n,m)
   -- Appel le ColorPicker puis la fonction de CallBack
   ------------------------------------------
   
   color_unit = m
   color_nom = tostring(n)
 
   ColorPickerFrame:SetColorRGB(r,v,b);
   ColorPickerFrame.hasOpacity, ColorPickerFrame.opacity = (a ~= nil), a;
   ColorPickerFrame.previousValues = {r,v,b,a};
   ColorPickerFrame.func, ColorPickerFrame.opacityFunc, ColorPickerFrame.cancelFunc = 
   Sh_opt_CPCallback, Sh_opt_CPCallback, Sh_opt_CPCallback;
   ColorPickerFrame:Hide();
   ColorPickerFrame:Show();
end

------------------------------------------
function Sh_opt_CPCallback(restore)
   -- Fonction de CallBack du ColorPicker
   ------------------------------------------
	local newR, newV, newB, newA;
	if restore then
		newR, newV, newB, newA = unpack(restore);
	else
		newA, newR, newV, newB = OpacitySliderFrame:GetValue(), ColorPickerFrame:GetColorRGB();
	end


	if color_unit then
		Ot[color_nom .. ":r"], Ot[color_nom .. ":v"], Ot[color_nom .. ":b"], Ot[color_nom .. ":a"] = newR, newV, newB, newA
	else
		O[color_nom .. ":r"], O[color_nom .. ":v"], O[color_nom .. ":b"], O[color_nom .. ":a"] = newR, newV, newB, newA
	end
   

	--------- Refresh des couleurs des CP des options
	if color_nom == "1" or color_nom == "2" or color_nom == "3" or color_nom == "4" or color_nom == "5" or color_nom == "6" or color_nom == "7" or color_nom == "8" or color_nom == "9" then
		for j=1,9 do
			color_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
			color_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
			
			
			Bf_textar[j]:SetTexture(Ot["tex_barre"])
			Bf_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"],(Ot["b:a"]/100))

			Bftar[j]:SetPoint("LEFT",Ot["iconsize"]*2 +Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
			Bftar[j]:SetHeight(Ot["f:hauteur"] -(Ot["insets:top"]+Ot["insets:bottom"]))

			
			Bf_tex[j]:SetTexture(O["tex_barre"])
			Bf_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"],(O["b:a"]/100))
		  
			Bf[j]:SetPoint("LEFT",O["iconsize"]*2 +O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
			Bf[j]:SetHeight(O["f:hauteur"] -(O["insets:top"]+O["insets:bottom"]))
		end
	else
	
		Sh_refresh()
	end

end


------------------------------------------
function Sh_opt_createCP(nb,texte,parent,r,v,b,a)
	-- Fonction de création d'un carré de couleur qui appel le CP
	------------------------------------------
	cp[nb] = CreateFrame("Frame","ColorPickerFrame",parent)
	cp[nb]:SetFrameStrata("HIGH")
	cp[nb]:SetWidth(45)
	cp[nb]:SetHeight(18)


	local text = cp[nb]:CreateFontString("ColorPickerText","MEDIUM","GameFontNormal")
	text:SetText(texte)
	text:SetTextHeight(12)
	text:SetTextColor(1,1,1,1)
	text:SetPoint("RIGHT", cp[nb], -55, 0)
	text:Show()
end


function Sh_opt_texte(texte,taille,parent,r,v,b)
	local text = parent:CreateFontString("TexteOption","MEDIUM","GameFontNormal")
	text:SetText(texte)
	text:SetTextHeight(taille)
	text:SetTextColor(r,v,b,1)
	text:Show()
	return text  
end
   
   
   
   
   
function Sh_opt()
   Sh_opt_menu()
   
   ------------------------------------------------------------------------------------
   ------------------------------------------  CREATION DU MENU
   ------------------------------------------------------------------------------------
      
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   ------------------------------------------ OPTIONS
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   local Shield_check = CreateFrame("frame", "Shield_check", ShieldHealth.panel)
   Shield_check:SetFrameStrata("HIGH")
   Shield_check:SetWidth(290)
   Shield_check:SetHeight(240)
   Shield_check:SetBackdrop({
         bgFile = "empty", 
         edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
         edgeSize = 11,
   });
   Shield_check:SetBackdropColor(1,0,0,0)
   Shield_check:SetPoint("LEFT",10,145)
   Shield_check:Show()
   
      
   local text_Shield_check = Shield_check:CreateFontString("texteOption","MEDIUM","GameFontNormal")
   text_Shield_check:SetText(L["Options"])
   text_Shield_check:SetTextHeight(15)
   text_Shield_check:SetTextColor(0.8,0.8,0,1)
   text_Shield_check:SetPoint("LEFT", Shield_check, 20, 95)
   text_Shield_check:Show()
   
   
   
   -----------------
	cb[1] = Sh_opt_createCheckbox("cb1", L["Activer"], Shield_check)
	cb[1]:SetPoint("RIGHT",-250,70)
	cb[1]:SetChecked(O["enable"])
	cb[1]:Show()

	cb[2] = Sh_opt_createCheckbox("cb2", L["Extase"], Shield_check)
	cb[2]:SetPoint("RIGHT",-125,70)
	cb[2]:SetChecked(O["enable_extase"])
	cb[2]:Show()
   
   	cb[3] = Sh_opt_createCheckbox("cb3", L["short"], Shield_check)
	cb[3]:SetPoint("RIGHT",-250,35)
	cb[3]:SetChecked(O["short"])
	cb[3]:Show()
	

	

	
	btn[1] = CreateFrame("Button", "btn1", Shield_check, "UIPanelButtonTemplate2")
	btn[1]:SetPoint("CENTER",0,-100)
	btn[1]:SetWidth(260)
	btn[1]:SetText(L["targettoplayer"])
	btn[1]:SetScript("OnClick",function() 
			local x1 = O["enable_extase"]
			local x2 = O["f:pos:1"]
			local x3 = O["f:pos:2"]
			local x4 = O["f:pos:3"]
			local x5 = O["f:pos:4"]
			local x6 = O["f:pos:5"] 
			local x7 = O["tex_barre"]
			local x8 = O["f:tex:fond"]
			local x9 = O["f:tex:border"]
			local x10 = O["font:val"]


			O = Sh_deep(Ot)
			
			O["enable_extase"] = x1
			O["f:pos:1"] = x2
			O["f:pos:2"] = x3
			O["f:pos:3"] = x4
			O["f:pos:4"] = x5
			O["f:pos:5"] = x6
			O["tex_barre"] = x7
			O["f:tex:fond"] = x8
			O["f:tex:border"] = x9
			O["font:val"] = x10
			
			
			Sh_refresh()
			Sh_opt_sliderVal(3)
			Sh_refresh_options()
			Sh_refresh()
			Sh_opt_sliderVal(3)

			
			Sh_opt_OK()
		end
	) 
	btn[1]:Show()
	


   -----------------------------------------
	
	local Shield_checktar = CreateFrame("frame", "Shield_checktar", ShieldHealth.panel)
	Shield_checktar:SetFrameStrata("HIGH")
	Shield_checktar:SetWidth(290)
	Shield_checktar:SetHeight(240)
	Shield_checktar:SetBackdrop({
         bgFile = "empty", 
         edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
         edgeSize = 11,
	})
	Shield_checktar:SetBackdropColor(1,0,0,0)
	Shield_checktar:SetPoint("LEFT",320,145)
	Shield_checktar:Show()

   
	local text_Shield_checktar = Shield_checktar:CreateFontString("texteOption","MEDIUM","GameFontNormal")
	text_Shield_checktar:SetText(L["Activertar"])
	text_Shield_checktar:SetTextHeight(15)
	text_Shield_checktar:SetTextColor(0.8,0.8,0,1)
	text_Shield_checktar:SetPoint("LEFT", Shield_checktar, 20, 95)
	text_Shield_checktar:Show()
   


   
   -----------------
	cbtar[1] = Sh_opt_createCheckbox("cbtar1", L["Activer"], Shield_checktar)
	cbtar[1]:SetPoint("RIGHT",-250,70)
	cbtar[1]:SetChecked(Ot["enable"])
	cbtar[1]:Show()
   
    cbtar[3] = Sh_opt_createCheckbox("cbtar3", L["short"], Shield_checktar)
	cbtar[3]:SetPoint("RIGHT",-250,35)
	cbtar[3]:SetChecked(Ot["short"])
	cbtar[3]:Show()
   
   
   
   	btn[21] = CreateFrame("Button", "btn21", Shield_checktar, "UIPanelButtonTemplate2")
	btn[21]:SetPoint("CENTER",0,-100)
	btn[21]:SetWidth(260)
	btn[21]:SetText(L["playertotarget"])
	btn[21]:SetScript("OnClick",function() 

			local x2 = Ot["f:pos:1"]
			local x3 = Ot["f:pos:2"]
			local x4 = Ot["f:pos:3"]
			local x5 = Ot["f:pos:4"]
			local x6 = Ot["f:pos:5"] 
			local x7 = Ot["tex_barre"]
			local x8 = Ot["f:tex:fond"]
			local x9 = Ot["f:tex:border"]
			local x10 = Ot["font:val"]

			
			Ot = Sh_deep(O)
			
			Ot["enable_extase"] = nil
			Ot["f:pos:1"] = x2
			Ot["f:pos:2"] = x3
			Ot["f:pos:3"] = x4
			Ot["f:pos:4"] = x5
			Ot["f:pos:5"] = x6
			Ot["tex_barre"] = x7
			Ot["f:tex:fond"] = x8
			Ot["f:tex:border"] = x9
			Ot["font:val"] = x10
			
			Sh_refresh()
			Sh_opt_sliderVal(23)
			Sh_refresh_options()
			Sh_refresh()
			Sh_opt_sliderVal(23)
			
			Sh_opt_OK()
		end
	) 
	btn[21]:Show()
   -----------------------------------------------
   
   
   
   
   
   
   	btn[42] = CreateFrame("Button", "btn42", ShieldHealth.panel, "UIPanelButtonTemplate2")
	btn[42]:SetPoint("LEFT",140,0)
	btn[42]:SetText(L["test"])
	btn[42]:SetScript("OnClick",function() if TESTMODE then TESTMODE = false; Sh_OnEvent() else TESTMODE = true; Sh_test() end end)
	btn[42]:SetWidth (125)
	btn[42]:Show()
	
	btn[43] = CreateFrame("Button", "btn43", ShieldHealth.panel, "UIPanelButtonTemplate2")
	btn[43]:SetPoint("LEFT",280,0)
	btn[43]:SetText(L["reset"])
	btn[43]:SetScript("OnClick",function() DEFAULT_CHAT_FRAME:AddMessage(sh_Local["reset1"]) end)
	btn[43]:SetScript("OnDoubleClick",function() Sh_reset() end)
	btn[43]:SetWidth (135)
	btn[43]:Show()
   
	btn[41] = CreateFrame("Button", "btn41", ShieldHealth.panel, "UIPanelButtonTemplate2")
	btn[41]:SetPoint("LEFT",10,0)
	btn[41]:SetText(L["Deverouiller"])
	btn[41]:SetScript("OnClick",function() btn[44]:Show(); Sh_opt_moveframe(true) end)
	btn[41]:SetWidth (125)
	btn[41]:Show()

	btn[44] = CreateFrame("Button", "btn44", UIParent, "UIPanelButtonTemplate2")
	btn[44]:SetPoint("CENTER",0,50)
	btn[44]:SetText(L["Verouiller"])
	btn[44]:SetWidth (120)
	btn[44]:SetScript("OnClick",function() btn[44]:Hide(); Sh_opt_moveframe(false) end)
	btn[44]:Hide()

   function Sh_opt_moveframe(bool)
		if bool then
			bg:RegisterForDrag("LeftButton")
			bg:SetMovable(true) 
			bg:EnableMouse(true)
			bg:SetScript("OnDragStart", function() bg:StartMoving() end)
			bg:SetScript("OnDragStop", function() bg:StopMovingOrSizing() O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"] = bg:GetPoint() Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"] = bgtar:GetPoint() end)
			bg:SetFrameLevel(O["level"]+50)
			 
			bgtar:RegisterForDrag("LeftButton")
			bgtar:SetMovable(true) 
			bgtar:EnableMouse(true)
			bgtar:SetScript("OnDragStart", function() bgtar:StartMoving() end)
			bgtar:SetScript("OnDragStop", function() bgtar:StopMovingOrSizing() O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"] = bg:GetPoint() Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"] = bgtar:GetPoint() end)
			bgtar:SetFrameLevel(Ot["level"]+50)
        else
			bg:SetMovable(false)
			bg:EnableMouse(false)
			O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"] = bg:GetPoint()
			ShieldHealth_SV["f:pos:1"],ShieldHealth_SV["f:pos:2"],ShieldHealth_SV["f:pos:3"],ShieldHealth_SV["f:pos:4"],ShieldHealth_SV["f:pos:5"] = O["f:pos:1"],O["f:pos:2"],O["f:pos:3"],O["f:pos:4"],O["f:pos:5"]
			bg:SetFrameLevel(O["level"])

			bgtar:SetMovable(false)
			bgtar:EnableMouse(false)
			Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"] = bgtar:GetPoint()
			ShieldHealth_SV2["f:pos:1"],ShieldHealth_SV2["f:pos:2"],ShieldHealth_SV2["f:pos:3"],ShieldHealth_SV2["f:pos:4"],ShieldHealth_SV2["f:pos:5"] = Ot["f:pos:1"],Ot["f:pos:2"],Ot["f:pos:3"],Ot["f:pos:4"],Ot["f:pos:5"]
			bgtar:SetFrameLevel(Ot["level"])
		end
	end
   
   

   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   ------------------------------------------ PLAYER
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------	
   ------------------------------------------ COULEUR DES BARRES
	
	local Shield_color = CreateFrame("frame", "Shield_color", ShieldHealth.childpanel_player)
	Shield_color:SetFrameStrata("HIGH")
	Shield_color:SetWidth(290)
	Shield_color:SetHeight(340)
	Shield_color:SetBackdrop({
        bgFile = "empty", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = 11,
	});
	Shield_color:SetBackdropColor(1,0,0,0)
	Shield_color:SetPoint("LEFT",320,100)
	Shield_color:Show()
	local text_Shield_color = Shield_color:CreateFontString("textecarre","MEDIUM","GameFontNormal")
	text_Shield_color:SetText(L["Couleur_des_Boucliers"])
	text_Shield_color:SetTextHeight(15)
	text_Shield_color:SetTextColor(0.8,0.8,0,1)
	text_Shield_color:SetPoint("LEFT", Shield_color, 20, 150)
	text_Shield_color:Show()
   
    local x1 = 160
	
	for j=1,9 do
		x1 = x1 - 30
		color[j] = CreateFrame("Frame","ColorPickerFrame" .. j,Shield_color)
		color[j]:SetFrameStrata("HIGH")
		color[j]:SetWidth(250)
		color[j]:SetHeight(18)

		color_text[j] = color[j]:CreateFontString("ColorPickerText" .. j,"MEDIUM","GameFontNormal")
		color_text[j]:SetText(B[j])
		color_text[j]:SetTextHeight(12)
		color_text[j]:SetTextColor(1,1,1,1)
		color_text[j]:SetPoint("LEFT", color[j], 10, 0)
		color_text[j]:Show()

		
		
		
		color[j]:SetPoint("LEFT",20,x1)
   		color[j]:SetScript("OnMouseDown", function() Sh_opt_showCP(O[j .. ":r"], O[j .. ":v"], O[j ..":b"],nil,Sh_opt_CPCallback,j,false) end)
				
		color_tex[j] = color[j]:CreateTexture(nil,"BACKGROUND")
		color_tex[j]:SetTexture(O["tex_barre"])
		color_tex[j]:SetVertexColor(O[j .. ":r"],O[j .. ":v"],O[j .. ":b"])
		color_tex[j]:SetAllPoints(color[j])
	  
	end
   
    Sh_opt_createSlider(1,"Slider1", Shield_color, O["b:a"], 0, 100, "b:a", true, false)
	slider[1]:SetPoint("CENTER", Shield_color,"CENTER",60,-143)
	
	local text_color_Shield1 = Sh_opt_texte(L["Transparence"], 12,Shield_color,1,1,1)
	text_color_Shield1:SetPoint("LEFT", Shield_color, 20, -143)
	
	
   ------------------------------------------------------------------------------------
   ------------------------------------------ TEXTURE ET FONT DES BARRE
   local Shield_tex = CreateFrame("frame", "Shield_tex", ShieldHealth.childpanel_player)
   Shield_tex:SetFrameStrata("HIGH")
   Shield_tex:SetWidth(290)
   Shield_tex:SetHeight(540)
   Shield_tex:SetBackdrop({
         bgFile = "empty", 
         edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
         edgeSize = 11,
   });
   Shield_tex:SetBackdropColor(1,0,0,0)
   Shield_tex:SetPoint("LEFT",10,0)
   Shield_tex:Show()
   
   local Shield_tex_hr = CreateFrame("frame", "Shield_tex_hr", ShieldHealth.childpanel_player)
   Shield_tex_hr:SetFrameStrata("HIGH")
   Shield_tex_hr:SetWidth(290)
   Shield_tex_hr:SetHeight(210)
   Shield_tex_hr:SetBackdrop({
         bgFile = "empty", 
         edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
         edgeSize = 11,
   });
   Shield_tex_hr:SetBackdropColor(1,0,0,1)
   Shield_tex_hr:SetPoint("LEFT",10,165)
   Shield_tex_hr:Show()
   
   
  
   
	--------------------
	local text_Shield_tex = Sh_opt_texte(L["Apparence_barre_boucliers"], 15,Shield_tex,0.8,0.8,0)
	text_Shield_tex:SetPoint("LEFT", Shield_tex, 10, 260)


	----------
	local text_Shield_tex2 = Sh_opt_texte(L["Texture_barre_boucliers"], 12,Shield_tex,1,1,1)
	text_Shield_tex2:SetPoint("LEFT", Shield_tex, 20, 240)


	Sh_opt_createDDM(1, Shield_tex, 240, M_statusbar, "tex_barre", "statusbar")
	Sh_DDM[1]:SetPoint("LEFT", 0, 220)

	----------
	local text_Shield_tex3 = Sh_opt_texte(L["Police_vie_boucliers"], 12,Shield_tex,1,1,1)
	text_Shield_tex3:SetPoint("LEFT", Shield_tex, 20, 195)


	Sh_opt_createDDM(2, Shield_tex, 240, M_font, "font:val", "font")
	Sh_DDM[2]:SetPoint("LEFT", 0, 175)

	----------
	Sh_opt_createCP(1,L["Couleur_texte"], Shield_tex, O["font:val:r"], O["font:val:v"], O["font:val:b"])
	cp[1]:SetPoint("LEFT",230,150)

	cp[1]:SetScript("OnMouseDown", function() Sh_opt_showCP(O["font:val:r"], O["font:val:v"], O["font:val:b"], O["font:val:a"],Sh_opt_CPCallback,"font:val",false) end)

	color_fontval_tex = cp[1]:CreateTexture(nil,"BACKGROUND")
	color_fontval_tex:SetTexture("Interface\\Buttons\\WHITE8X8")
	color_fontval_tex:SetVertexColor(O["font:val:r"],O["font:val:v"],O["font:val:b"],O["font:val:a"])
	color_fontval_tex:SetAllPoints(cp[1])

		 
	----------
	Sh_opt_createSlider(2, "Slider2", Shield_tex, O["font:val:size"], 1, 30, "font:val:size", true, false)
	slider[2]:SetPoint("CENTER", Shield_tex,"CENTER",70,120)


	local text_Shield_tex0 = Sh_opt_texte(L["Taille_texte"], 12,Shield_tex,1,1,1)
	text_Shield_tex0:SetPoint("LEFT", Shield_tex, 20, 120)

	----------
	cb[5] = Sh_opt_createCheckbox("cb5", L["Contour"], Shield_tex)
	cb[5]:SetPoint("LEFT",20,150)
	cb[5]:SetChecked(O["contour"])
	cb[5]:Show()
   --------------------
   --------------------
   local text_Shield_tex4 = Sh_opt_texte(L["Apparence_generale"], 15,Shield_tex,0.8,0.8,0)
   text_Shield_tex4:SetPoint("LEFT", Shield_tex, 10, 55)
   
   ----------
   Sh_opt_createSlider(3, "Slider3", Shield_tex, O["f:largeur"], O["f:largeur"]-100, O["f:largeur"]+100, "f:largeur", false, false)
   slider[3]:SetPoint("CENTER", Shield_tex,"CENTER",70,35)
   
   
   local text_Shield_tex5 = Sh_opt_texte(L["Largeur_globale"], 12,Shield_tex,1,1,1)
   text_Shield_tex5:SetPoint("LEFT", Shield_tex, 20, 35)
   
   ----------
   Sh_opt_createSlider(4, "Slider4", Shield_tex, O["f:hauteur"], 1, 100, "f:hauteur", true, false)
   slider[4]:SetPoint("CENTER", Shield_tex,"CENTER",70,5)
   
   local text_Shield_tex6 = Sh_opt_texte(L["Hauteur_globale"], 12,Shield_tex,1,1,1)
   text_Shield_tex6:SetPoint("LEFT", Shield_tex, 20, 5)
   
   ----------
   local text_Shield_tex7 = Sh_opt_texte(L["Texture_bordure_generale"], 12,Shield_tex,1,1,1)
   text_Shield_tex7:SetPoint("LEFT", Shield_tex, 20, -20)
   
   
   Sh_opt_createDDM(3, Shield_tex, 240, M_border, "f:tex:border", "border")
   Sh_DDM[3]:SetPoint("LEFT", 0, -40)
   
   ----------
   Sh_opt_createSlider(5, "Slider5", Shield_tex, O["border:size"], 0, 50, "border:size", true, false)
   slider[5]:SetPoint("CENTER", Shield_tex,"CENTER",70,-75)
   
   
   local text_Shield_tex11 = Sh_opt_texte(L["Taille_bordure"], 12,Shield_tex,1,1,1)
   text_Shield_tex11:SetPoint("LEFT", Shield_tex, 20, -75)
   
   ---------
   local text_Shield_tex16 = Sh_opt_texte(L["insets"], 12,Shield_tex,1,1,1)
   text_Shield_tex16:SetPoint("LEFT", Shield_tex, 20, -90)  
   ---------
	Sh_opt_createSlider(10, "Slider10", Shield_tex, O["insets:left"], 0, 20, "insets:left", true, false)
	slider[10]:SetPoint("LEFT", Shield_tex,"LEFT",20,-115)
	slider[10]:SetWidth(50)
	slidermoins[10]:Hide()
	sliderplus[10]:Hide()
	local text_Shield_tex14 = Sh_opt_texte(L["left"], 12,Shield_tex,1,1,1)
	text_Shield_tex14:SetPoint("LEFT", Shield_tex, 25, -135)  

	
	Sh_opt_createSlider(11, "Slider11", Shield_tex, O["insets:right"], 0, 20, "insets:right", true, false)
	slider[11]:SetPoint("LEFT", Shield_tex,"LEFT",85,-115)
	slider[11]:SetWidth(50)
	slidermoins[11]:Hide()
	sliderplus[11]:Hide()
	local text_Shield_tex15 = Sh_opt_texte(L["right"], 12,Shield_tex,1,1,1)
	text_Shield_tex15:SetPoint("LEFT", Shield_tex, 90, -135) 
   
   
	Sh_opt_createSlider(12, "Slider12", Shield_tex, O["insets:top"], 0, 20, "insets:top", true, false)
	slider[12]:SetPoint("LEFT", Shield_tex,"LEFT",150,-115)
	slider[12]:SetWidth(50)
	slidermoins[12]:Hide()
	sliderplus[12]:Hide()
	local text_Shield_tex15 = Sh_opt_texte(L["top"], 12,Shield_tex,1,1,1)
	text_Shield_tex15:SetPoint("LEFT", Shield_tex, 155, -135) 
	
	
	Sh_opt_createSlider(13, "Slider13", Shield_tex, O["insets:bottom"], 0, 20, "insets:bottom", true, false)
	slider[13]:SetPoint("LEFT", Shield_tex,"LEFT",215,-115)
	slider[13]:SetWidth(50)
	slidermoins[13]:Hide()
	sliderplus[13]:Hide()
	local text_Shield_tex15 = Sh_opt_texte(L["bottom"], 12,Shield_tex,1,1,1)
	text_Shield_tex15:SetPoint("LEFT", Shield_tex, 220, -135) 

   -----------------------------------------------------------------------
   local text_Shield_tex8 = Sh_opt_texte(L["Texture_fond"], 12,Shield_tex,1,1,1)
   text_Shield_tex8:SetPoint("LEFT", Shield_tex, 20, -155)
   
   Sh_opt_createDDM(4, Shield_tex, 240, M_background, "f:tex:fond", "background")
   Sh_DDM[4]:SetPoint("LEFT", 0, -175)
   
   ---------
   Sh_opt_createCP(2,L["Couleur_fond"], Shield_tex, O["f:SBC:r"], O["f:SBC:v"], O["f:SBC:b"])
   cp[2]:SetPoint("LEFT",230,-200)
   
   cp[2]:SetScript("OnMouseDown", function() Sh_opt_showCP(O["f:SBC:r"], O["f:SBC:v"], O["f:SBC:b"], O["f:SBC:a"],Sh_opt_CPCallback,"f:SBC",false) end)
   
    color_fontval_tex2 = cp[2]:CreateTexture(nil,"BACKGROUND")
	color_fontval_tex2:SetTexture(O["f:tex:fond"])
	color_fontval_tex2:SetVertexColor(O["f:SBC:r"],O["f:SBC:v"],O["f:SBC:b"],O["f:SBC:a"])
	color_fontval_tex2:SetAllPoints(cp[2])
   ----------
   Sh_opt_createSlider(6, "Slider6", Shield_tex, O["iconsize"], 0, 100, "iconsize", true, false)
   slider[6]:SetPoint("CENTER", Shield_tex,"CENTER",70,-225)
   
   local text_Shield_tex9 = Sh_opt_texte(L["Taille_icones"], 12,Shield_tex,1,1,1,"LEFT", 20, -207)
   text_Shield_tex9:SetPoint("LEFT", Shield_tex, 20, -225)
   
   
   Sh_opt_createSlider(7, "Slider7", Shield_tex, O["level"], 1, 100, "level", true, false)
   slider[7]:SetPoint("CENTER", Shield_tex,"CENTER",70,-250)
   
   local text_Shield_tex10 = Sh_opt_texte(L["level"], 12,Shield_tex,1,1,1,"LEFT", 20, -247)
   text_Shield_tex10:SetPoint("LEFT", Shield_tex, 20, -250)
   
   
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   ------------------------------------------ TARGET
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   
     ------------------------------------------ COULEUR DES BARRES
	
	local Shield_colortar = CreateFrame("frame", "Shield_colortar", ShieldHealth.childpanel_target)
	Shield_colortar:SetFrameStrata("HIGH")
	Shield_colortar:SetWidth(290)
	Shield_colortar:SetHeight(340)
	Shield_colortar:SetBackdrop({
        bgFile = "empty", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = 11,
	});
	Shield_colortar:SetBackdropColor(1,0,0,0)
	Shield_colortar:SetPoint("LEFT",320,100)
	Shield_colortar:Show()
	local text_Shield_colortar = Shield_colortar:CreateFontString("textecarretar","MEDIUM","GameFontNormal")
	text_Shield_colortar:SetText(L["Couleur_des_Boucliers"])
	text_Shield_colortar:SetTextHeight(15)
	text_Shield_colortar:SetTextColor(0.8,0.8,0,1)
	text_Shield_colortar:SetPoint("LEFT", Shield_colortar, 20, 150)
	text_Shield_colortar:Show()
   
    local x1 = 160
	
	for j=1,9 do
		x1 = x1 - 30
		colortar[j] = CreateFrame("Frame","ColorPickerFrame" .. j,Shield_colortar)
		colortar[j]:SetFrameStrata("HIGH")
		colortar[j]:SetWidth(250)
		colortar[j]:SetHeight(18)

		color_texttar[j] = colortar[j]:CreateFontString("ColorPickerText" .. j,"MEDIUM","GameFontNormal")
		color_texttar[j]:SetText(B[j])
		color_texttar[j]:SetTextHeight(12)
		color_texttar[j]:SetTextColor(1,1,1,1)
		color_texttar[j]:SetPoint("LEFT", colortar[j], 10, 0)
		color_texttar[j]:Show()

		
		
		
		colortar[j]:SetPoint("LEFT",20,x1)
   		colortar[j]:SetScript("OnMouseDown", function() Sh_opt_showCP(Ot[j .. ":r"], Ot[j .. ":v"], Ot[j ..":b"],nil,Sh_opt_CPCallback,j,true) end)
				
		color_textar[j] = colortar[j]:CreateTexture(nil,"BACKGROUND")
		color_textar[j]:SetTexture(Ot["tex_barre"])
		color_textar[j]:SetVertexColor(Ot[j .. ":r"],Ot[j .. ":v"],Ot[j .. ":b"])
		color_textar[j]:SetAllPoints(colortar[j])
	  
	end
   
    Sh_opt_createSlider(21, "slider26", Shield_colortar, Ot["b:a"], 0, 100, "b:a", true, true)
	slider[21]:SetPoint("CENTER", Shield_colortar,"CENTER",60,-143)
	
	local text_color_Shield1tar = Sh_opt_texte(L["Transparence"], 12,Shield_colortar,1,1,1)
	text_color_Shield1tar:SetPoint("LEFT", Shield_colortar, 20, -143)
	

	
   ------------------------------------------------------------------------------------
   ------------------------------------------ TEXTURE ET FONT DES BARRE
   local Shield_textar = CreateFrame("frame", "Shield_textar", ShieldHealth.childpanel_target)
   Shield_textar:SetFrameStrata("HIGH")
   Shield_textar:SetWidth(290)
   Shield_textar:SetHeight(540)
   Shield_textar:SetBackdrop({
         bgFile = "empty", 
         edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
         edgeSize = 11,
   });
   Shield_textar:SetBackdropColor(1,0,0,0)
   Shield_textar:SetPoint("LEFT",10,0)
   Shield_textar:Show()
   
   local Shield_tex_hrtar = CreateFrame("frame", "Shield_tex_hrtar", ShieldHealth.childpanel_target)
   Shield_tex_hrtar:SetFrameStrata("HIGH")
   Shield_tex_hrtar:SetWidth(290)
   Shield_tex_hrtar:SetHeight(210)
   Shield_tex_hrtar:SetBackdrop({
         bgFile = "empty", 
         edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
         edgeSize = 11,
   });
   Shield_tex_hrtar:SetBackdropColor(1,0,0,1)
   Shield_tex_hrtar:SetPoint("LEFT",10,165)
   Shield_tex_hrtar:Show()
   
   
  
   
   --------------------
   local text_Shield_textar = Sh_opt_texte(L["Apparence_barre_boucliers"], 15,Shield_textar,0.8,0.8,0)
   text_Shield_textar:SetPoint("LEFT", Shield_textar, 10, 260)
   
   
   ----------
   local text_Shield_tex2tar = Sh_opt_texte(L["Texture_barre_boucliers"], 12,Shield_textar,1,1,1)
   text_Shield_tex2tar:SetPoint("LEFT", Shield_textar, 20, 240)
   
   
   Sh_opt_createDDM(21, Shield_textar, 240, M_statusbar, "tex_barre", "statusbar",true)
   Sh_DDM[21]:SetPoint("LEFT", 0, 220)
   
   ----------
   local text_Shield_tex3tar = Sh_opt_texte(L["Police_vie_boucliers"], 12,Shield_textar,1,1,1)
   text_Shield_tex3tar:SetPoint("LEFT", Shield_textar, 20, 195)
   
   
   Sh_opt_createDDM(22, Shield_textar, 240, M_font, "font:val", "font",true)
   Sh_DDM[22]:SetPoint("LEFT", 0, 175)
   
   ----------
   Sh_opt_createCP(21,L["Couleur_texte"], Shield_textar, Ot["font:val:r"], Ot["font:val:v"], Ot["font:val:b"])
   cp[21]:SetPoint("LEFT",230,150)
   
   cp[21]:SetScript("OnMouseDown", function() Sh_opt_showCP(Ot["font:val:r"], Ot["font:val:v"], Ot["font:val:b"], Ot["font:val:a"],Sh_opt_CPCallback,"font:val",true) end)
   
   	color_fontval_textar = cp[21]:CreateTexture(nil,"BACKGROUND")
	color_fontval_textar:SetTexture("Interface\\Buttons\\WHITE8X8")
	color_fontval_textar:SetVertexColor(Ot["font:val:r"],Ot["font:val:v"],Ot["font:val:b"],Ot["font:val:a"])
	color_fontval_textar:SetAllPoints(cp[21])
   
		 
   ----------
   Sh_opt_createSlider(22, "slider21", Shield_textar, Ot["font:val:size"], 1, 30, "font:val:size", true, true)
   slider[22]:SetPoint("CENTER", Shield_textar,"CENTER",70,120)
   
   
   local text_Shield_tex0tar = Sh_opt_texte(L["Taille_texte"], 12,Shield_textar,1,1,1)
   text_Shield_tex0tar:SetPoint("LEFT", Shield_textar, 20, 120)
   
   	----------
	cbtar[5] = Sh_opt_createCheckbox("cbtar5", L["Contour"], Shield_textar)
	cbtar[5]:SetPoint("LEFT",20,150)
	cbtar[5]:SetChecked(O["contour"])
	cbtar[5]:Show()
   --------------------
   --------------------
   local text_Shield_tex4tar = Sh_opt_texte(L["Apparence_generale"], 15,Shield_textar,0.8,0.8,0)
   text_Shield_tex4tar:SetPoint("LEFT", Shield_textar, 10, 55)
   
   ----------
   Sh_opt_createSlider(23, "slider22", Shield_textar, Ot["f:largeur"], Ot["f:largeur"]-100, Ot["f:largeur"]+100, "f:largeur", false,true)
   slider[23]:SetPoint("CENTER", Shield_textar,"CENTER",70,35)
   
   
   local text_Shield_tex5tar = Sh_opt_texte(L["Largeur_globale"], 12,Shield_textar,1,1,1)
   text_Shield_tex5tar:SetPoint("LEFT", Shield_textar, 20, 35)
   
   ----------
   Sh_opt_createSlider(24, "slider23", Shield_textar, Ot["f:hauteur"], 1, 100, "f:hauteur", true,true)
   slider[24]:SetPoint("CENTER", Shield_textar,"CENTER",70,5)
   
   local text_Shield_tex6tar = Sh_opt_texte(L["Hauteur_globale"], 12,Shield_textar,1,1,1)
   text_Shield_tex6tar:SetPoint("LEFT", Shield_textar, 20, 5)
   
   ----------
   local text_Shield_tex7tar = Sh_opt_texte(L["Texture_bordure_generale"], 12,Shield_textar,1,1,1)
   text_Shield_tex7tar:SetPoint("LEFT", Shield_textar, 20, -20)
   
   
   Sh_opt_createDDM(23, Shield_textar, 240, M_border, ":tex:border", "border",true)
   Sh_DDM[23]:SetPoint("LEFT", 0, -40)
   
   ----------
   Sh_opt_createSlider(25, "slider24", Shield_textar, Ot["border:size"], 0, 50, "border:size", true,true)
   slider[25]:SetPoint("CENTER", Shield_textar,"CENTER",70,-75)
   
   local text_Shield_tex11tar = Sh_opt_texte(L["Taille_bordure"], 12,Shield_textar,1,1,1)
   text_Shield_tex11tar:SetPoint("LEFT", Shield_textar, 20, -75)
   
	----------
	local text_Shield_textar16 = Sh_opt_texte(L["insets"], 12,Shield_textar,1,1,1)
	text_Shield_textar16:SetPoint("LEFT", Shield_textar, 20, -90) 
	----------
	Sh_opt_createSlider(30, "Slider30", Shield_textar, Ot["insets:left"], 0, 20, "insets:left", true, true)
	slider[30]:SetPoint("LEFT", Shield_textar,"LEFT",20,-115)
	slider[30]:SetWidth(50)
	slidermoins[30]:Hide()
	sliderplus[30]:Hide()
	local text_Shield_textar14 = Sh_opt_texte(L["left"], 12,Shield_textar,1,1,1)
	text_Shield_textar14:SetPoint("LEFT", Shield_textar, 25, -135)  

	
	Sh_opt_createSlider(31, "Slider31", Shield_textar, Ot["insets:right"], 0, 20, "insets:right", true, true)
	slider[31]:SetPoint("LEFT", Shield_textar,"LEFT",85,-115)
	slider[31]:SetWidth(50)
	slidermoins[31]:Hide()
	sliderplus[31]:Hide()
	local text_Shield_textar16 = Sh_opt_texte(L["right"], 12,Shield_textar,1,1,1)
	text_Shield_textar16:SetPoint("LEFT", Shield_textar, 90, -135) 
   
   
	Sh_opt_createSlider(32, "Slider32", Shield_textar, Ot["insets:top"], 0, 20, "insets:top", true, true)
	slider[32]:SetPoint("LEFT", Shield_textar,"LEFT",150,-115)
	slider[32]:SetWidth(50)
	slidermoins[32]:Hide()
	sliderplus[32]:Hide()
	local text_Shield_textar17 = Sh_opt_texte(L["top"], 12,Shield_textar,1,1,1)
	text_Shield_textar17:SetPoint("LEFT", Shield_textar, 155, -135) 
	
	
	Sh_opt_createSlider(33, "Slider33", Shield_textar, Ot["insets:bottom"], 0, 20, "insets:bottom", true, true)
	slider[33]:SetPoint("LEFT", Shield_textar,"LEFT",215,-115)
	slider[33]:SetWidth(50)
	slidermoins[33]:Hide()
	sliderplus[33]:Hide()
	local text_Shield_textar18 = Sh_opt_texte(L["bottom"], 12,Shield_textar,1,1,1)
	text_Shield_textar18:SetPoint("LEFT", Shield_textar, 220, -135) 
	
	
   ----------
   local text_Shield_tex8tar = Sh_opt_texte(L["Texture_fond"], 12,Shield_textar,1,1,1)
   text_Shield_tex8tar:SetPoint("LEFT", Shield_textar, 20, -155)
   
   Sh_opt_createDDM(24, Shield_textar, 240, M_background, "f:tex:fond", "background",true)
   Sh_DDM[24]:SetPoint("LEFT", 0, -175)
   
   ---------
   Sh_opt_createCP(22,L["Couleur_fond"], Shield_textar, Ot["f:SBC:r"], Ot["f:SBC:v"], Ot["f:SBC:b"])
   cp[22]:SetPoint("LEFT",230,-200)
   
   cp[22]:SetScript("OnMouseDown", function() Sh_opt_showCP(Ot["f:SBC:r"], Ot["f:SBC:v"], Ot["f:SBC:b"], Ot["f:SBC:a"],Sh_opt_CPCallback,"f:SBC",true) end)
   
    color_fontval_tex2tar = cp[22]:CreateTexture(nil,"BACKGROUND")
	color_fontval_tex2tar:SetTexture(Ot["f:tex:fond"])
	color_fontval_tex2tar:SetVertexColor(Ot["f:SBC:r"],Ot["f:SBC:v"],Ot["f:SBC:b"],Ot["f:SBC:a"])
	color_fontval_tex2tar:SetAllPoints(cp[22])
   ----------
   Sh_opt_createSlider(26, "slider25", Shield_textar, Ot["iconsize"], 0, 100, "iconsize", true,true)
   slider[26]:SetPoint("CENTER", Shield_textar,"CENTER",70,-225)
   
   local text_Shield_tex9tar = Sh_opt_texte(L["Taille_icones"], 12,Shield_textar,1,1,1,"LEFT", 20, -247)
   text_Shield_tex9tar:SetPoint("LEFT", Shield_textar, 20, -225)
   
   Sh_opt_createSlider(27, "slider27", Shield_textar, Ot["level"], 1, 100, "level", true, true)
   slider[27]:SetPoint("CENTER", Shield_textar,"CENTER",70,-250)
   
   local text_Shield_tex10tar = Sh_opt_texte(L["level"], 12,Shield_textar,1,1,1,"LEFT", 20, -247)
   text_Shield_tex10tar:SetPoint("LEFT", Shield_textar, 20, -250) 
   
   
   
   
   
   
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
   --------------------------------- ORDRE DES BOUCLIERS
   ------------------------------------------------------------------------------------
   ------------------------------------------------------------------------------------
    

   	local Shield_ordre = CreateFrame("frame", "Shield_ordre", ShieldHealth.childpanel_ordre)
	Shield_ordre:SetFrameStrata("HIGH")
	Shield_ordre:SetWidth(400)
	Shield_ordre:SetHeight(310)
	Shield_ordre:SetBackdrop({
        bgFile = "empty", 
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
        edgeSize = 11,
	});
	Shield_ordre:SetBackdropColor(1,0,0,0)
	Shield_ordre:SetPoint("LEFT",10,115)
	Shield_ordre:Show()
	local text_Shield_ordre = Shield_ordre:CreateFontString("text_ordre","MEDIUM","GameFontNormal")
	text_Shield_ordre:SetText(L["Ordre"])
	text_Shield_ordre:SetTextHeight(15)
	text_Shield_ordre:SetTextColor(0.8,0.8,0,1)
	text_Shield_ordre:SetPoint("LEFT", Shield_ordre, 10, 130)
	text_Shield_ordre:Show()
	
 
   

   
	for j=1,9 do
		ordre[j] = CreateFrame("Frame","Ordre" .. j,Shield_ordre)
		ordre[j]:SetHeight(20)
		ordre[j]:SetWidth(300)
		--ordre[j]:SetPoint("LEFT",20,135-(30*O["Ord"][j]))
		ordre[j]:Show()
		
		text_ordre[j] = ordre[j]:CreateFontString("text","MEDIUM","GameFontNormal")
		text_ordre[j]:SetText(B[j])
		text_ordre[j]:SetTextHeight(14)
		text_ordre[j]:SetTextColor(1,1,1)
		text_ordre[j]:SetPoint("LEFT", ordre[j], 0, 0)
		text_ordre[j]:Show()
		
		
		up_ordre[j] =  CreateFrame("Button", "OrdreUp" .. j, ordre[j], "UIPanelScrollUpButtonTemplate")
		up_ordre[j]:SetPoint("LEFT", 198, 0)
		up_ordre[j]:SetScript("OnClick",function()
			for k=1,9 do 
				if O["Ord"][k] == j then
					if k ~= 1 then
						local _,_,_,_,x1 = ordre[j]:GetPoint()
						ordre[j]:SetPoint("LEFT",20,x1+30)
						
						ordre[O["Ord"][k-1] ]:SetPoint("LEFT",20,x1)
						O["Ord"][k],O["Ord"][k-1] = O["Ord"][k-1],O["Ord"][k]
						break
					end
				end
			end
		end)
		up_ordre[j]:SetWidth(20)
		up_ordre[j]:Show()
		
		
		down_ordre[j] =  CreateFrame("Button", "OrdreDown" .. j, ordre[j], "UIPanelScrollDownButtonTemplate")
		down_ordre[j]:SetPoint("LEFT", 217, 0)
		down_ordre[j]:SetScript("OnClick",function()
					for k=1,9 do 
						if O["Ord"][k] == j then
							if k ~= 9 then
								local _,_,_,_,x1 = ordre[j]:GetPoint()
								ordre[j]:SetPoint("LEFT",20,x1-30)
							
								ordre[O["Ord"][k+1] ]:SetPoint("LEFT",20,x1)
								O["Ord"][k],O["Ord"][k+1] = O["Ord"][k+1],O["Ord"][k]
								break
							end
						end
					end
				end
			)
		down_ordre[j]:SetWidth(20)
		down_ordre[j]:Show()
		
		
		toggle_ordre[j] = Sh_opt_createCheckbox("OrdreToggleCb" .. j, "", ordre[j])
		toggle_ordre[j]:SetPoint("LEFT",260,0)
		toggle_ordre[j]:SetChecked(O["Ord:toggle"][j])
		toggle_ordre[j]:SetScript("OnClick",function()
					O["Ord:toggle"][j] = toggle_ordre[j]:GetChecked()
					Sh_OnEvent()
				end
			)
		toggle_ordre[j]:Show()
		
		
		toggle_icon[j] = Sh_opt_createCheckbox("OrdreIconCb" .. j, "", ordre[j])
		toggle_icon[j]:SetPoint("LEFT",310,0)
		toggle_icon[j]:SetChecked(O["Ord:icon"][j])
		toggle_icon[j]:SetScript("OnClick",function()
					O["Ord:icon"][j] = toggle_icon[j]:GetChecked()
					Sh_OnEvent()
				end
			)
		toggle_icon[j]:Show()
	end
	local toggle_ordre_text = Sh_opt_texte(L["Activer"], 12,Shield_ordre,1,1,1,"LEFT", 270, 130)
	toggle_ordre_text:SetPoint("LEFT", Shield_ordre, 270, 125)
	
	local toggle_icon_text = Sh_opt_texte(L["Icone"], 12,Shield_ordre,1,1,1,"LEFT", 325, 130)
	toggle_icon_text:SetPoint("LEFT", Shield_ordre, 325, 125)
	
   
   ------------------------------------------------------------------------------------
   ------------------------------------------
   Sh_refresh()
   
end
------------------------------------------







function Sh_test()
if TESTMODE then



	ft1tar:SetText(L["target"])


	ftar:Show()
	i1tar:Hide()
	i2tar:Hide()

  
	i1_textar:SetTexture(Btex[5])
	i1tar:Show()
	i1CDtar:SetCooldown(GetTime(),15)
	i2_textar:SetTexture(Btex[6])
	i2tar:Show()
	i2CDtar:SetCooldown(GetTime()-2,15)
	

	fbtar:SetPoint("LEFT",Ot["iconsize"]*2 + Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	fbtar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))
	fb2tar:SetPoint("LEFT",Ot["iconsize"]*2 + Ot["insets:left"],((Ot["insets:bottom"]-Ot["insets:top"])/2))
	fb2tar:SetWidth(Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))

	
	for j=1,9 do Bftar[j]:SetWidth(1) Bf[j]:Hide() end
	
	Bftar[5]:Show()
	Bftar[5]:SetWidth((Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))/4)
	Bftar[5]:SetPoint("LEFT",0,0)
	
	Bftar[6]:Show()
	Bftar[6]:SetWidth((Ot["f:largeur"]-(Ot["iconsize"]*2 + Ot["insets:left"]+Ot["insets:right"]))/2.5)
	Bftar[6]:SetPoint("LEFT",Bftar[5]:GetWidth(),0)
	

	
	
	
	
	
	ft1:SetText(L["player"])
	

	f:Show()
	i1:Hide()
	i2:Hide()

  
	i1_tex:SetTexture(Btex[1])
	i1:Show()
	i1CD:SetCooldown(GetTime(),60)
	i2_tex:SetTexture(Btex[2])
	i2:Show()
	i2CD:SetCooldown(GetTime()-10,60)
	

	fb:SetPoint("LEFT",O["iconsize"]*2 + O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	fb:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))
	fb2:SetPoint("LEFT",O["iconsize"]*2 + O["insets:left"],((O["insets:bottom"]-O["insets:top"])/2))
	fb2:SetWidth(O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))

	Bf[1]:Show()
	Bf[1]:SetWidth((O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))/2)
	Bf[1]:SetPoint("LEFT",0,0)
	
	Bf[2]:Show()
	Bf[2]:SetWidth((O["f:largeur"]-(O["iconsize"]*2 + O["insets:left"]+O["insets:right"]))/4)
	Bf[2]:SetPoint("LEFT",Bf[1]:GetWidth(),0)
	
	for j=3,9 do Bf[j]:SetWidth(1) Bf[j]:Hide() end
end
end

function Sh_reset()
	for j=1,9 do
	ordre[j]:SetPoint("LEFT",20,110-(25*O["Ord"][j]))
	end

	Sh_options()
	ShieldHealth_SV = O
	ShieldHealth_SV2 = Ot
	Sh_refresh_options()
	Sh_refresh()
	DEFAULT_CHAT_FRAME:AddMessage(sh_Local["reset2"])
end


-----------------------------
function Sh_deep (t, done)
-- Copie de tables
-- Source : http://www.gammon.com.au/forum/?id=8042
-----------------------------
  assert (type (t) == "table", "You must specify a table to copy")

  local result = {}
  done = done or {}

  assert (not done [t], "table is defined within itself")

  done [t] = true -- we will disallow recopying table t

  for k, v in pairs (t) do
    if type (v) == "table"  then
      result [k] = Sh_deep (v, done)
    else
      result [k] = v
    end -- if table or not
  end -- for each table element

  done [t] = nil -- table t can be copied again

  -- copy the metatable
  return setmetatable (result, getmetatable (t))

end -- function deep

Sh_OnLoad()